
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <bios.h>
#include "..\..\dtc2.h"

#define BINARY

FILE *fd;
char PP0[] = "            d  bapof         dias \n";
char PP1[] = "----------------------------------\n";
char PP2[] = "nnnnnn  R  00  00000xxx  xxxx0000 \n";
#ifdef BINARY
char buf[1024];
#endif

static unsigned char rlink(void)
{
  while ((inportb(C012+2)&1)==0) if (bioskey(1)) return(0xff);
  return(inportb(C012));
}

static void wlink(unsigned char b)
{
 unsigned t;

  t=0xffff; while (((inportb(C012+3)&1)==0)&&(--t));
  outportb(C012+1,b);
}


int main(void)
{
 char far *QR;
 long k;
 ulong t,v;
 int i,j,bh,bl,ofs,dir;
 char s1[10],s2[10];

  outportb(FPGA,0);
  outportb(oDRES,0);
  QR=MK_FP(0xcc00,0);
  QR[0x201]=2;

  t=1000000l;
  while (((inportb(C012+2)&1)==0) && (--t));
  if (t==0) {
    printf("No answer from T5\n"); exit(1);
   }

#ifdef BINARY
  fd=fopen("capt.bin","wb");
#else
  fd=fopen("capt.log","wt");
#endif
  k=rlink()&0xff;
  v=rlink()&0xff; k|=(v<<8);
  v=rlink()&0xff; k|=(v<<16);
  v=rlink()&0xff; k|=(v<<24);
  printf("%ld bytes captured\n",k);

#ifdef BINARY
  i=0;
  while (k--) {
    buf[i++]=rlink();
    if (bioskey(1)) { bioskey(0); break; }
    if (i==1024) {
      fwrite(buf,1,1024,fd); fflush(fd);
      i=0;
      printf(".");
     }
   }
  if (i) fwrite(buf,1,i,fd);
#else
  v=0;
  strcpy(s1,"00000xxx");
  strcpy(s2,"xxxx0000");

  while (k > 0) {
    bh=rlink(); bl=rlink(); k-=2;
    if (bioskey(1)) { bioskey(0); break; }
    ofs=bh&3; dir=bh&0x40;
    if ((v&0x3f)==0) {
      fprintf(fd,"\f%s%s",PP0,PP1);
      if ((v&0xff)==0) printf(".");
     }
    sprintf(PP2,"%06ld  %c",v,(dir? 'W':'R'));
    switch(ofs) {
      case 0: sprintf(PP2+9,"  %02x\n",bl); break;
      case 1: for (j=0; j<5; j++) { s1[j]=(bl&0x80? '1':'0'); bl<<=1; }
	      sprintf(PP2+9,"      %s\n",s1); break;
      case 2: for (j=0; j<4; j++) { s2[7-j]=(bl&1)+'0'; bl>>=1; }
	      sprintf(PP2+9,"                %s\n",s2); break;
      case 3: sprintf(PP2+9,"3   %02x\n",bl); break;
     }
    fprintf(fd,"%s",PP2);
    v++;
   }
#endif
  printf("\nDone\n");
  fclose(fd);

  outportb(oDMODE,1);
  outportb(0x160,1);
  delay(100);
  outportb(0x160,0);
  outportb(oDRES,1);
  return(0);
}

