
#include "..\dtc2.h"

#define BTROM

int fpgaconfPC(char *);
int fpgaconfPROM(void);
int fpgaconfTAB(void);
int fpgatest(void);

char far *QRAM = NULL;

char fn[64] = "dtc2x.bit";
int resetX,resetP,resetT,ispause;
int HWxmode;

char dline[] = "-------------------------------------------------------------------";

extern unsigned char INV[];

int in_debug_mode=0;
int bootmode=0,Resetp=0,LoadFile=0,StopMon=0,is4003a=0;
char lodfile[256];
unsigned lowestP;

OnCEregs Oregs;
DSPregs  Dregs;

ulong bk_hi=0,bk_lo=0,bk_cnt=0;
int   isbk=0;

/* ----------------------------------------------------------------- */


void PAUSE(void)
{
  if (ispause) {
    printf("--Paused--\n");
    getch();
   }
}


static void near wr1link(char b)
{
 int t=20000;
  while (((inportb(C012+3)&1)==0)&&(--t));
  if (t) outportb(C012+1,b);
}

static int near rd1link(void)
{
 int t=20000;
  while (((inportb(C012+2)&1)==0)&&(--t));
  return (t? inportb(C012):-1);
}

static void near wr4link(ulong v)
{
  wr1link(v&0xff); v>>=8;
  wr1link(v&0xff); v>>=8;
  wr1link(v&0xff); v>>=8;
  wr1link(v&0xff);
}

static ulong near rd4link(void)
{
 ulong v;
  v =(long)rd1link();
  v|=((long)rd1link()<<8);
  v|=((long)rd1link()<<16);
  v|=((long)rd1link()<<24);
  return(v);
}


static long near dspread_t(long t)
{
 long v;

  while (((inp(HI_ISR)&0xf1)==0)&&(--t)); if (t==0) return(-1l);
  asm {	mov	dx,345h;
	in	al,dx;
	xor	cx,cx;
	mov	cl,al;
	inc	dx;
	in	al,dx;
	mov	ah,al;
	inc	dx;
	in	al,dx;
	mov	word ptr v,ax;
	mov	word ptr v+2,cx;
       }
  return(v);
}


/* ----------------------------------------------------------------- */


void resetall(void)
{
  outportb(oTANALY,0);
  outportb(oTRESET,0);
  outportb(oECF2,1);
  outportb(oECF3,0);
  outportb(oTRESET,1);	/* reset T425 */
  outportb(oDRES,0);	/* reset DSP  */
  outportb(oXMODE,0);
  outportb(oDMODE,0);
  outportb(oXPROG,0);	/* inv */
  delay(100);
  outportb(oTRESET,0);
}


int memtest(void)
{
 char far *mem[3] =
  { (char far *)0xc8000000l,(char far *)0xcc000000l,(char far *)0xd0000000l };
 char far *p;
 int i,k,srch;

  srch=(QRAM==NULL);
  printf(srch? "Memory test":"Environment");

  if (srch) {
    for (k=0; k<3; k++) {
      p=mem[k];
      i=p[M401+6];
      outportb(M401+6,0x55);
      if (p[M401+6]==0x55) {
	outportb(M401+6,0xaa);
	if (p[M401+6]==0xaa) break;
       }
      p[M401+6]=i;
     }
    if (k>=3) return(1);
    QRAM=mem[k];
  }
  printf(" says QRAM at %08lx ",(unsigned long)QRAM);

  printf("*");
  p=QRAM;
  for (i=0; i<1024; i++) {
    *p++=0xaa;
   }
  printf("*");
  p=QRAM;
  for (i=0; i<1024; i++) {
    if (*p!=0xaa) return(1);
    *p++=i&0xff;
   }
  printf("*");
  p=QRAM;
  for (i=0; i<1024; i++) {
    if (*p!=(i&0xff)) return(1);
    *p++=0xff;
   }
  printf("*");
  p=QRAM;
  for (i=0; i<1024; i++) {
    if (*p!=0xff) return(1);
    *p++=0;
   }
  printf("*");
  p=QRAM;
  for (i=0; i<1024; i++) {
    if (*p!=0) return(1);
   }
  return(0);
}


/* ------------------------------------------------------------------- */


int C012test(void)
{
 int i,r2,r3;

  outportb(oTRESET,1);	/* reset T425 */
  delay(100);
  outportb(oTRESET,0);
  printf("C012: %02x %02x %02x %02x",inportb(C012),inportb(C012+1),
	(r2=inportb(C012+2)),(r3=inportb(C012+3)));
  if ((r2!=0) || (r3!=1)) return(1);
  outportb(C012+2,2);
  if (inportb(C012+2)!=2) return(2);
  outportb(C012+2,0);
  outportb(C012+3,2);
  if (inportb(C012+3)!=3) return(3);
  outportb(C012+3,0);

  return(0);
}


int T_test(void)
{
 ulong u,v;

  u=0x55aa5aa5;
  wr1link(0); wr4link(0x80000080); wr4link(u);	/* poke */
  wr1link(1); wr4link(0x80000080); v=rd4link();
  if (u==v) {
    u=0xaa334679;
    wr1link(0); wr4link(0x80000800); wr4link(u);	/* poke */
    wr1link(1); wr4link(0x80000800); v=rd4link();
    return (u!=v);
   }
  return(1);
}


int dspstart(void)		/* try to start DSP from Flash */
{
 int err;
 long v;

#ifdef BTROM
  outportb(oDMODE,1);
  outportb(oDRES,1);
  delay(200);
  err=0; v=-1l;
  if (inp(HI_ISR)==0xff) err=1; else {
    v=dspread_t(1000000);
   }
  printf("DSP init from ROM says %06lx\n",v);
  if (v!=0x56002) err=1;
  outportb(oDMODE,0);
  return(err);
#else
  return(0);
#endif
}


/* ------------------------------------------------------------------- */


void main (int argc, char *argv[])
{
 char buf[128];
 int err,terr,retcode,i,j,k,n;
 int FPGAmode,FPGAdone,FPGAerr;
 char *p;

  printf("%s\nDTC2 init ["__DATE__" "__TIME__"]\n",dline);
  resetX=0; resetP=0; resetT=0;
  ispause=0;

  retcode=0;
  for (i=0; i<255; i++) {
    j=i; k=0;
    for (n=0; n<7; n++) { if (j&1) k|=1; j>>=1; k<<=1; }
    INV[i]=k|j;
   }

  k=argc; *buf=0;
  while (--k) {
    p=argv[k];
    if ((*p=='-')||(*p=='/')) {
      switch(p[1]) {
	case 'a': is4003a=(p[2]!='-'); break;
	case 'p': ispause=(p[2]!='-'); break;
/* -rp=PROM -rf=FILE -r|-rt=TABLE */
	case 'r': if (p[2]=='p') resetP=(p[3]!='-');
		  else
		   if (p[2]=='f') resetX=(p[3]!='-');
		   else
		    if (p[2]=='t') resetT=(p[3]!='-');
		     else resetT=(p[2]!='-');
		  break;
	default:  break;
       }
     }
    else strcpy(buf,p);
  }
  if (resetX && *buf) strcpy(fn,buf);

  if (!DTC2present(&QRAM)) {
    printf("DTC2 not found\n"); retcode=1;
    goto quit;
   }

  resetall();

  FPGAerr = inportb(iXINIT)&1;
  FPGAdone = inportb(iXDONE)&1;
  FPGAmode = inportb(iXMODE)&1;

  err=0;
  printf("FPGA mode=%d err=%d done=%d - ",FPGAmode,FPGAerr,FPGAdone);
  k = inportb(iXDONE)&1;
  if (!k) printf("FPGA not configured\n");
    else printf("FPGA already configured\n");
/*  if (resetX||resetP) printf("reconfiguring FPGA\n"); */

  if ((!k)||resetX||resetP||resetT) {
    if (resetP) {
      outportb(oXMODE,HWxmode);
      err=fpgaconfPROM();
     }
    else if (resetX||resetT) {
/* reset from PC - put in mode 1 */
      outportb(oXMODE,!HWxmode);
      if (resetX) {
	if (err=fpgaconfPC(fn)) {
	  printf("Oops..."); err=fpgaconfPC(fn);
	 }
       }
      else if (resetT) {
	if (err=fpgaconfTAB()) {
	  printf("Oops..."); err=fpgaconfTAB();
	 }
       }
     }
   }

  if (!err) {
    delay(50);
/* test echo of CTRL0 bit */
    outportb(FPGA,1);
    if ((inportb(FPGA+1)&0x20)==0) err=1;
    outportb(FPGA,0);
    if ((inportb(FPGA+1)&0x20)!=0) err=1;
   }
  if (err) {
    printf("error in FPGA config\n");
    retcode=1; goto quit;
   }
  outportb(oXMODE,!HWxmode);	/* set FPGA mode always to 1 */
  printf("FPGA version is %02x:%02x\n",inportb(FPGA),inportb(FPGA+1));

  if (memtest()) {
    printf(" Error\n");
   }
  else printf(" OK\n");

  if (terr=C012test()) {
    printf(" - Error %d in C012 test\n",terr);
   }
  else {
    printf(" - C012 test ok");
    if (T_test())
      printf(" - Error in T425 test\n");
    else
      printf(" - T425 test ok\n");
   }

  err=dspstart();

quit:
  printf("%s\n",dline);
  if (terr)
    outportb(oTRESET,1);	/* reset T425 */
  if (err)
    outportb(oDRES,0);		/* reset DSP  */
  outportb(FPGA,0);		/* special feature off */

  exit(retcode);
}

