
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <ctype.h>
#include <string.h>
#include <go32.h>
#include <dos.h>
#include <sys/farptr.h>
#include "portio.h"

#define BASED	"c:\\dtc2\\"
#define BASEL	"c:\\dtc2\\lod\\"
#define BITFILE	BASED##"dtcx2.bit"
#define FILET1	BASEL##"boot.lod"
#define FILET2	BASEL##"memtest1.lod"
#define FILET3	BASEL##"memtest2.lod"
#define FILET4	BASEL##"adtest.lod"
#define FILET5	BASEL##"m401test.lod"
#define FILET6	BASEL##"captest.lod"

typedef unsigned long ulong;
typedef unsigned short ushort;
typedef unsigned char uchar;

#define USEACK		1

#define DBUFSIZ		8192	/* DSP code buffer */
#define CBUFSIZ		4096	/* capture buffer */

#define BUSWAIT		asm out 0x80,al

/* ==================================================================== */
/*	ALS259 bits, W/O, 0160-0167					*/
/* ==================================================================== */

#define oTRESET		0x160
#define oTANALY		0x161
#define oECF2		0x162
#define oECF3		0x163
#define oXMODE		0x164
#define oDRES		0x165
#define oDMODE		0x166
#define oXPROG		0x167

/* ==================================================================== */
/*	DTC/2 XC4003 FPGA - base version				*/
/*
	Addr
	0150-0158	R/W	C012 (decode)
	0178		W	Control lines
				b0	IRQ9 enable (capture)
				b1	IRQ5 enable (C012 IRQ)
				b2	EVREN EvReq enable
				b3	Reset 401 registers
				b4	NMI enable (capture)
				b5	TFIRQ enable to DSP (capture)
			R	capture data bus
	0179		R	capture addr/flags
				b0-b2	addr bus b0-b2
				b3-b4	capture port
					00	no port
					01	0378
					10	03bc
					11	0100
				b5	IRQ9 enable echo
				b6	capture R(1)/W(0)
				b7	doble capture error
	0301-0307(odd)	R	M401 status bits
				b6	0=ready to write
				b7	0=ready to read
	0300-0306(even)	R/W	M401 data register (=QRAM:030x)
	0301-0307(odd)	W	M401 control register (=QRAM:030x)
	0340-0347	R/W	56002 host port
	0348		W	b0	1=set DR,clr ACK
					0=clr DR,clr ACK
	0348		R	OnCE status
				b0	DSI/OS0
				b1	DSCK/OS1
				b2	ACK
				b3	Q5ACT
				b4	DSO
	0349		R/W	OnCE data register
	034A		W	start OnCE send/receive
	034B		W	b0	EvReq enable(1) if EVREN=1
	034B		R	T-status
				b0	EvAck
				b1	EvReq
				b2	IINT
				b3	OINT

   unused pins on FPGA:
	5	12	13	21	24	30	33
	36	37	45	47	48	59	65
	72
 */
/* ==================================================================== */

typedef struct
  {
    unsigned char db;		/* from read 0x179 */
    union
      {
	unsigned char a;
	struct
	  {
	    unsigned int ab:3;
	    unsigned int ch:2;
	    unsigned int en:1;
	    unsigned int rw:1;
	    unsigned int err:1;
	  }
	b;
      }
    eb;
  }

CaptElem;

#define FPGA		0x178

#define M401		0x300

#define DSP56		0x340
#define ONCE		0x348
#define C012		0x150

#define IDECS0		0x170
#define IDECS1		0x374

#define iXINIT		0x160
#define iXDONE		0x164
#define iXMODE		0x168
#define iLOCAL		0x16c

/* mpu-401 command and message summary */

#define     NOTE_OFF            0x80	/* MIDI voice messages - channel 1 */
#define     NOTE_ON             0x90
#define     POLY_AFTERTOUCH     0xA0
#define     MODE_MESSAGE        0xB0
#define     PROGRAM_CHANGE      0xC0
#define     AFTERTOUCH          0xD0
#define     PITCH_WHEEL         0xE0
#define     ALL_NOTES_OFF       0x7B	/* channel mode message */

/* mpu marks */

#define NOP             0xf8	/* no operation */
#define MES_END         0xf9	/*  measure end */
#define DATA_END        0xfc	/*  end data */

/* ----------------------------------------------------------------- */

#define HI_ICR		(DSP56)
#define HI_CVR		(DSP56+1)
#define HI_ISR		(DSP56+2)
#define HI_IVR		(DSP56+3)
#define HI_TXH 		(DSP56+5)
#define HI_TXM 		(DSP56+6)
#define HI_TXL 		(DSP56+7)
#define HI_RXH 		HI_TXH
#define HI_RXM          HI_TXM
#define HI_RXL          HI_TXL

#define MS_X	0
#define MS_Y	1
#define MS_P	2
#define MS_R	3
#define MS_E	4

#define HC_Peek		0x12
#define HC_Poke		0x13
#define HC_Fill		0x14

typedef enum
  {
    sStart, sEnd, sData, sBlock, sSymb, sComm, sNorec
  } rectyp;

/* ----------------------------------------------------------------- */

#define OnCEstat	ONCE
#define OnCEdat		ONCE+1	/* write data,no clock */
#define OnCEclk		ONCE+2	/* write=clk */

typedef struct _OnCEregs
  {
    /* 00000 */ ulong SCR;	/* 16bit R/W */
    /* 00001 */ ulong MBCR;	/* 24bit R/W */
    /* 00011 */ ulong TR;	/* 24bit R/W */
    /* 00110 */ ulong MULR;	/* 16bit R/W */
    /* 00111 */ ulong MLLR;	/* 16bit R/W */
    /* 01000 */ ulong GDBR;	/* 24bit R/O */
    /* 01001 */ ulong PDBR;	/* 24bit R/W */
    /* 01010 */ ulong PABFR;	/* 16bit R/O */
    /* 01011 */ ulong PILR;	/* 24bit R/O */
    /* 01100 */ ulong MBCC;	/* clear MBC */
    /* 01110 */ ulong TC;	/* clear TR  */
    /* 10001 */ ulong PABfifo[5];	/* 16bit R/O */
    /* 10011 */ ulong PABDR;	/* 16bit R/O */
  } OnCEregs;

typedef struct _DSPregs
  {
    ulong X0, X1, Y0, Y1;
    uchar A2;
    ulong A1, A0;
    uchar B2;
    ulong B1, B0;
    ushort R[8], N[8], M[8];
    ushort SR, OMR, LA, LC;
    ushort SP;
  } DSPregs;


/* OnCE command register - bits 0-4=register no. */
#define O_read		0x80
#define O_write		0x00
#define O_go		0x40
#define O_nogo		0x00
#define O_ex		0x20
#define O_noex		0x00

/* OnCE registers */
#define O_OSCR		0x00	/* status/control register */
#define O_OMBC		0x01	/* memory breakpoint counter */
#define O_OTC		0x03	/* trace counter */
#define O_OMULR		0x06	/* memory upper limit register */
#define O_OMLLR		0x07	/* memory lower limit register */
#define O_OGDBR		0x08	/* global data bus register */
#define O_OPDBR		0x09	/* program data bus register */
#define O_OPABFR	0x0A	/* PAB register for fetch */
#define O_OPILR		0x0B	/* pipeline instruction latch register */
#define O_OCMBC		0x0C	/* clear memory breakpoint counter */
#define O_OCTC		0x0E	/* clear trace counter */
#define O_FIFO		0x11
#define O_OPABDR	0x13	/* PAB register for decode */
#define O_noreg		0x1F

/* OnCE status/control register 0x00 */
/* 16 bits, MSB aligned */
#define O_OSCR_TO	0x400	/* trace occurrence, R/O */
#define O_OSCR_MBO	0x200	/* memory breakpoint occurrence, R/O */
#define O_OSCR_SWO	0x100	/* SW debug occurrence, R/O */
#define O_OSCR_TME	0x10	/* Trace mode enable, R/W */
#define O_OSCR_BC	0x0f	/* mask for breakpoint mode */

/* breakpoint modes, bits 0-3 of SCR */
#define O_nobrk		0x0
#define O_brk_fetch	0x1	/* fetch+aborted instructions */
#define O_brk_readPf	0x2	/* read P+fetch */
#define O_brk_accessP	0x3	/* read+write+fetch P */
#define O_brk_xfetch	0x4	/* executed fetches */
#define O_brk_writeP	0x5	/* write P */
#define O_brk_readP	0x6	/* read P, no fetch */
#define O_brk_rwP	0x7	/* read+write P */
#define O_brk_writeX	0x9
#define O_brk_readX	0xa
#define O_brk_rwX	0xb
#define O_brk_writeY	0xd
#define O_brk_readY	0xe
#define O_brk_rwY	0xf

#define O_GmovR		0x08C03Cl	/* movep reg,X:OGDB */
#define O_RmovG		0x08403Cl	/* movep X:OGDB,reg */
#define O_ImovR		0x40f400l	/* move #>$xxxxxx,reg */
#define O_ImovM		0x05f400l	/* move #>$xxxxxx,reg */

/* OR with register - order:
	0x400	x0,x1,y0,y1
	0x800	a0,b0,a2,b2,a1,b1,a,b
	0x1000	r0..r7
	0x1800	n0..n7
	0x2000	m0..m7
	0x2800	-------
	0x3900	sr,omr,sp,ssh,ssl,la,lc
*/
#define reg_X0		0x04	/* 0x00000002 */
#define reg_X1		0x05	/* 0x00000001 */
#define reg_Y0		0x06	/* 0x00000008 */
#define reg_Y1		0x07	/* 0x00000004 */
#define reg_A0		0x08	/* 0x00000040 */
#define reg_B0		0x09	/* 0x00000200 */
#define reg_A2		0x0a	/* 0x00000010 */
#define reg_B2		0x0b	/* 0x00000080 */
#define reg_A1		0x0c	/* 0x00000020 */
#define reg_B1		0x0d	/* 0x00000100 */
#define reg_A 		0x0e
#define reg_B 		0x0f
#define reg_R0		0x10
#define reg_R(r)	(0x10+(r))	/* 0x0003FC00 */
#define reg_N0		0x18
#define reg_N(r)	(0x18+(r))	/* 0x0003FC00 */
#define reg_M0		0x20
#define reg_M(r)	(0x20+(r))	/* 0x0003FC00 */
#define reg_SR		0x39	/* 0x00040000 */
#define reg_OMR		0x3a	/* 0x00080000 */
#define reg_SP		0x3b	/* 0x00100000 */
#define reg_SSH		0x3c	/* 0x00200000: do not read! */
#define reg_SSL		0x3d	/* 0x00400000: do not read! */
#define reg_LA		0x3e	/* 0x00800000 */
#define reg_LC		0x3f	/* 0x01000000 */

#define msk_X0		0x00000002l
#define msk_X1		0x00000001l
#define msk_Y0		0x00000008l
#define msk_Y1		0x00000004l
#define msk_A0		0x00000040l
#define msk_B0		0x00000200l
#define msk_A2		0x00000010l
#define msk_B2		0x00000080l
#define msk_A1		0x00000020l
#define msk_B1		0x00000100l
#define msk_RNM(r)	(1l << ((r)+10))
#define msk_SR		0x00040000l
#define msk_OMR		0x00080000l
#define msk_SP		0x00100000l
#define msk_SSH		0x00200000l	/* do not read! */
#define msk_SSL		0x00400000l	/* do not read! */
#define msk_LA		0x00800000l
#define msk_LC		0x01000000l

#define O_moviR0	0x60F400l	/* move #xxxx,r0   */
#define O_moviX0	0x44F400l	/* move #xxxxxx,x0 */

#define O_movR0p	0x08D87Cl	/* move S:(r0)+,X:OGDB */
#define O_movAp		0x08F07Cl	/* move abs,X:OGDB     */
/* OR with  P=0x00  X=0x40  Y=0x80 */

#define O_jmplong	0x0AF080l	/* jmp >$xxxx   */

/* -------------------------------------------------------------------- */

#define OnCEwdat16(r,v,a)	OnCEwdat((r),((long)(v)<<8),(a))

#define ReadSCR()		OnCErdat(O_OSCR|O_read)
#define WriteSCR(v)		OnCEwdat(O_OSCR|O_write,v,0)
#define ReadPDB()		OnCErdat(O_OPDBR|O_read)
#define WritePDB(v)		OnCEwdat(O_OPDBR|O_write,v,0)
#define WritePDBAck(v)		OnCEwdat(O_OPDBR|O_write,v,1)
#define WritePDBgo(v)		OnCEwdat(O_OPDBR|O_write|O_go,v,0)
#define WritePDBgoAck(v)	OnCEwdat(O_OPDBR|O_write|O_go,v,1)
#define Execute1i(v)		WritePDBgoAck(v)
#define Execute2i1(v)		WritePDBAck(v)
#define Execute2i2(v)		WritePDBgoAck(v)
#define WritePDBex(v)		OnCEwdat(O_OPDBR|O_write|O_ex,v,0)
#define WritePDBgoex(v)		OnCEwdat(O_OPDBR|O_write|O_go|O_ex,v,0)
#define ReadGDB()		OnCErdat(O_OGDBR|O_read)
#define ReadGDBgo()		OnCErdat(O_OGDBR|O_read|O_go)
#define ReadGDBex()		OnCErdat(O_OGDBR|O_read|O_ex)
#define NOPgo()			send_command(O_noreg|O_go)

#define begin_debug(r)		begin_debug_run(r,0)
#define begin_debug_res(r)	begin_debug_run(r,1)
#define end_debug(r)		end_debug_go(r,0)
#define end_debug_cont(r)	end_debug_go(r,0)

#define loadX(a,n)		OnCEwmem('x',a,n,DSPBUF)
#define loadY(a,n)		OnCEwmem('y',a,n,DSPBUF)
#define loadP(a,n)		OnCEwmem('p',a,n,DSPBUF)
#define fillX(a,n,v)		OnCEfillmem('x',a,n,v)
#define fillY(a,n,v)		OnCEfillmem('y',a,n,v)
#define fillP(a,n,v)		OnCEfillmem('p',a,n,v)
#define clearX(a,n)		OnCEfillmem('x',a,n,0)
#define clearY(a,n)		OnCEfillmem('y',a,n,0)
#define clearP(a,n)		OnCEfillmem('p',a,n,0)

#define delay(n)	usleep((n)*1000)

/* -------------------------------------------------------------------- */

int DTC2present (long * QRAM);
int OnCEfakeboot (void);
int OnCEreq (void);
int OnCErunmode (void);
int enterOnCE (int reset);
long OnCErdat (unsigned char reg);
int OnCEwdat (int reg, ulong v, int ack);
int begin_debug_run (OnCEregs * o, int reset);
int end_debug_go (OnCEregs * o, ulong a);	/* if a==0 no jump */
int OnCEtrace (OnCEregs * o, ulong n, ulong a);
int OnCEbrkgo (OnCEregs * o);
int OnCEdebgo (OnCEregs * o);
ulong OnCErreg (int r);		/* r = register NUM */
int OnCEwreg (int r, ulong v);	/* r = register NUM */
int OnCEgetallreg (DSPregs * r, ulong mask);
int OnCErmem (char space, ulong a, int n, ulong * buf);
int OnCEwmem (char space, ulong a, int n, ulong * buf);
int OnCEfillmem (char space, ulong a, int n, ulong v);
unsigned OnCEloadDSP (char *fname, ulong * dspbuf);
void OnCEshowallreg (DSPregs * r, OnCEregs * o, FILE * fe);
int OnCEgetregn (char *p, FILE * fe);
int OnCEputregn (char *p, ulong v);

int disasm56 (ushort a, ulong (*F) (ushort, int), FILE * fd);

/* -------------------------------------------------------------------- */
