/* $Id: dspads.h,v 1.25 1993/01/04 22:45:04 rich Exp $ */
/*
 *
 *
 *	DSPADS.H	MAIN HEADER FILE FOR DSPADS USER INTERFACE
 *
 *	THIS FILE CONTAINS LABEL, STRUCTURE, AND MISCELLANEOUS
 *	DEFINITIONS FOR MODULES PERTAINING TO THE USER INTERFACE.
 *
 *	Rev. 05-08-1991
 *	Rev. 06-06-1991 - gdb - 1)changed XMEM,YMEM,PMEM defs to MEM_X,MEM_Y,MEM_P
 *				and added MEM_L,MEM_T. Globally replaced all refs to these
 *				with the new names in all modules.
 *				2)added #ifdef for sun4 version of IOCPARM_MASK
 *				3)removed def for TOTLREGS.
*/


/* Set up attributes for each part type */
#define DSP_ATTRIB      DSP_REVC|DSP_WRD24|DSP_ADDR16
#define DSP_NUMBYTES    3
#define NUM_MEM_SPACES  4
#define BYTES_PER_MOVEP_OPCODE 6
#define MAXADDR         0xffffl
#define MAXDATA         0xffffffl
#define SIGNBIT         0x800000l
#define TREG			108
#define MREG			90

#define  DSP_BINARY      0
#define  DSP_DECIMAL     1
#define  DSP_FRACTIONAL  2
#define  DSP_FLOAT       2
#define  DSP_HEX         3
#define  DSP_UNSIGNED    4

#define YES	1
#define NO	0
#define	DSP_NO_ERR	0
#define	DSP_ERROR	(-1)

#define NOT_USED 0

#define TRUE	1
#define FALSE	0

#define BIG_ENDIAN 0

/* memory selection info */
#define NONE_SELECTED 0
#define INTERNAL      1  
#define EXTERNAL      2  
#define CC_YMEM       0  
#define CC_XMEM       1  
#define CC_PMEM	      2

#define MEM_OFFSET 200 /* mem types start at 200 */
#define BYTEWIDE 0
#define WORDWIDE 1
#define CCLOAD 2

#define LOADBUF 256 /* words per data transfer */
#define MAXIOBUF 256 /* maximum words in an io transfer */

#define CMDBUFFER	20	/* Command buffer size */
#define CMDBUFFSIZE	256	/* Command buffer size */

/* commands for MDSPSETADM */
#define set_adm_type    0
#define set_adm_active  1
#define set_active_type 2

/* dsp device types */
#define DSP56116        0x98
#define DSP56156        0x99
#define DSP56166        0x9a
#define DSP56000        0x20
#define DSP56001        0x21
#define DSP56002        0xa2
#define DSP56004        0xa3
#define DSP96002        0xc4
#define DSP96002I       0xc5

/* dsp generic types */
#define DSP16bit        0x10
#define DSP24bit        0x20
#define DSP32bit        0x40
#define DSPONCE         0x80

#if UNIX

/*
 *	This is device driver information for VME based systems
 */
#define SEEK_CUR 1
#define SEEK_END 2
#define SEEK_SET 0
/***
 *
 * This def needed for sun4 systems. This also appears in unix dev. drvr.
 *
 ***/
struct fakeit {
	char fake[_IOCPARM_MASK-1];
    };
/* mdsp_ioctl commands */
#define MDSPRESET	_IOW(m,1,int)		/* set adm reset line */
#define MDSPBREAK	_IOW(m,2,int)		/* force adm break */
#define MDSPCOMMAND	_IOW(m,3,struct fakeit) /* send read command */
#define MDSPSELECT	_IOW(m,4,int)		/* select an adm for a group */
#define MDSPDESELECT	_IOW(m,5,int)		/* deselect an adm group */
#define MDSPCLEAR	_IOW(m,6,int)		/* clear adm reset line */
#define MDSPWBYTE	_IOW(m,7,int)		/* write byte to data addr */
#define MDSPRBYTE	_IOWR(m,8,int)		/* read byte from data addr */
#define MDSPDEVICE	_IOW(m,9,int)		/* set mdspsoftc.ctrl1 ADM */
#define MDSPIOW 	_IOW(m,10,int)		/* write to an address */
#define MDSPIOR 	_IOWR(m,11,int) 	/* read from an address */

#define MDSPSETADM       _IOW(m,19,int)          /* set adm types/actives */
#define MDSPVERSION      _IOWR(m,20,char[120])   /* return driver version */
#endif

#define CTRL1 0 	/* control register address offset */
#define DATA 1		/* data register address offset */
#define CTRL2 2 	/* control register 2 address offset */

/*	ADM and Host interface signal description	*/
/* ADM inputs */
#define HST_REQ 2
#define HST_ACK 4
/* ADM outputs */
#define ADM_INT 1
#define ADM_REQ 2
#define ADM_ACK 4
/* Host Inputs	*/
#define HST_BRK 8
/* Host outputs */
#define ADM_BRK 1
#define HST_REQ 2
#define HST_ACK 4
#define ADM_ALL 8
#define ADM_RESET 0x80
#define BRACE_SEL 0x20
#define INT_ACK 0x40
#define ADM_GROUP 0x80
/*
 * IBM keyboard constants
 */
#define  ESC			27
#define  BLANK			32
#define  ZERO			48
#define  FREEZE 		1
#define  THAW			0
#define  CTLKMAX		32
#define  CTRLC			0x03
#define  CTRLX			0x18
#define  CTRLBRK		0x80
#define  NORM			2
#define  HIGHLITE		3
#define  BINARY 		0
#define  DECIMAL		1
#define  FRACTIONAL		2
#define  FLOAT			2	/* replaces fractional in 96002 */
#define  HEX			3
#define  UNSIGNED		4
#define  COMMANDS		41   /* TOTAL NUMBER OF COMMANDS */
#define  NOCHAR 		(-1)
#define  NICE			'~'  /* printable ascii characters */
#define  FOUND			1
#define  NOTFOUND		0
#define  ALL			1     /* to signify purge of all macros */
#define  MAXADS 		8     /* current limitation */
#define  MAXACTNS		10    /* maximum breakpoint actions in one breakpoint */
#define  MAXBREAK		99    /* maximum number of breakpoints */
/*
 *	SCROLL commands
 */
#define UPSROL		71
#define DNSROL		72
#define SCRLUP1 	97
#define SCRLDN1 	98
/*
 *	Load and Save Record Types for program/data/io type Object Files
 */
#define START	10
#define END	20
#define DAITA	30
#define BLOCKDATA 40
#define COMMENT 50
#define SYMBOL	60
#define ERROR	(-1)
#define MAXOBJ	6

/* DSP REGISTER INDEXES FOR LONG REGISTER ARRAY */

/* Core registers */

#define FIRST_CORE_REG	1
#define LONG_A		0
#define REG_A0		1
#define REG_A1 		2
#define REG_A2 		3
#define LONG_B 		4
#define REG_B0 		5
#define REG_B1 		6
#define REG_B2 		7
#define MR_BCR 		8	/****** The 56004 does not have a bcr ********/
#define MR_IPR 		9   /* This is really memory mapped to x:$ffff   */
#define REG_LA 		10
#define REG_LC		11
#define REG_M0 		12
#define REG_M1 		13
#define REG_M2 		14
#define REG_M3 		15
#define REG_M4 		16
#define REG_M5 		17
#define REG_M6 		18
#define REG_M7 		19
#define REG_N0 		20
#define REG_N1 		21
#define REG_N2 		22
#define REG_N3 		23
#define REG_N4 		24
#define REG_N5 		25
#define REG_N6 		26
#define REG_N7 		27
#define REG_OMR 	28
#define REG_PC 		29
#define REG_R0 		30
#define REG_R1 		31
#define REG_R2 		32
#define REG_R3 		33
#define REG_R4 		34
#define REG_R5 		35
#define REG_R6 		36
#define REG_R7 		37
#define REG_SP 		38
#define REG_SR 		39
#define REG_SSH 	40
#define REG_SSL 	41
#define LONG_X 		42
#define REG_X0 		43
#define REG_X1 		44
#define LONG_Y 		45
#define REG_Y0 		46
#define REG_Y1 		47
#define LAST_CORE_REG	47


/* Stack locations: This is only applicable to parts without OnCE */

/* Memory mapped registers */

#define FIRST_MM_REG	48

/* HOST PORT REGISTERS */
#define MR_HRX 		48 	/* HOST RECEIVE REGISTER FFEB */
#define MR_HCR  	49 	/* HOST CONTROL REGISTER FFE8 */
#define MR_HSR  	50 	/* HOST STATUS REGISTER FFE9 */
#define MR_HTX  	51 	/* HOST TRANSMIT REGISTER FFEB */

#define MR_SSIRX 	52 	/* SSI RX REGISTER FFEF */
#define MR_SSICA 	53 	/* SSI CRA FFEC */
#define MR_SSICB 	54 	/* SSI CRB FFED */
#define MR_SSISR 	55 	/* SSI STATUS REGISTER FFEE */
#define MR_TSR		56	/* SSI TIME SLOT REGISTER FFEE */
#define MR_SSITX 	57 	/* SSI TX REGISTER FFEF */

#define MR_STX 		58 	/* SCI TRANSMIT BYTE FFF6,FFF5,FFF4*/
#define MR_SCR 		59 	/* SCI CONTROL REGISTER FFF0 */
#define MR_SSR 		60 	/* SCI STATUS REGISTER FFF1 */
#define MR_SCCR 	61 	/* SCI CLOCK CONTROL REGISTER FFF2 */
#define MR_STXA 	62 	/* SCI TX. ADDRESS FFF3 */
#define MR_SRX 		63 	/* SCI RECEIVE BYTE LOW=FFF4,MED=FFF5,HI=FFF6*/

/* PORTB/C REGISTERS */
#define MR_PBC 		64 	/* PORT B CONTROL REGISTER FFE0 */
#define MR_PCC 		65 	/* PORT C CONTROL REGISTER FFE1 */
#define MR_PBDDR 	66 	/* PORT B DATA DIRECTION REGISTER FFE2 */
#define MR_PCDDR 	67 	/* PORT C DATA DIRECTION REGISTER FFE3 */
#define MR_PBD  	68 	/* PORT B DATA REGISTER FFE4 */
#define MR_PCD  	69 	/* PORT C DATA REGISTER FFE5 */

#define MR_PCTL 	70 	/* PLL CONTROL REGISTER FFFD */


/* DUMMY Definitions to satisfy compiler in sim5600/emi56k.c */
/* These registers do not actually exist on 56k2			  */

#define MR_EBAR0     0
#define MR_EOR0      0
#define MR_EDRR0     0
#define MR_ECSR      0
#define MR_EBAR1     0
#define MR_EOR1      0
#define MR_EDRR1     0
#define MR_ERCR      0
#define MR_EDWR0     0
#define MR_EDWR1     0

/* DUMMY Definitions to satisfy compiler in sim5600/sai56k.c */
/* These registers do not actually exist on 56k2			  */

#define MR_BRC		 0
#define MR_RCS		 0
#define MR_RX0		 0
#define MR_RX1		 0
#define MR_TCS		 0
#define MR_TX0		 0
#define MR_TX1		 0
#define MR_TX2		 0

/* DUMMY Definitions to satisfy compiler in sim5600/shi56k.c */
/* These registers do not actually exist on 56k2			  */

#define MR_HCKR		 0
#define MR_HCSR		 0
#define MR_HSAR		 0
#define MR_GPIOR	 0

#define LAST_MM_REG	70



/* ADS counters in c code */

#define CNT1  		71
#define CNT2  		72
#define CNT3  		73
#define CNT4  		74




/* ONCE REGISTER SET */

#define REG_OSCR 	75
#define REG_OMBC 	76
#define REG_OTC  	77
#define REG_OMULR 	78
#define REG_OMLLR 	79
#define REG_OGDBR 	80
#define REG_OPDBR 	81
#define REG_OPABFR 	82
#define REG_OPILR 	83
#define REG_OPABF4 	84
#define REG_OPABF3 	85
#define REG_OPABF2	86
#define REG_OPABF1 	87
#define REG_OPABF0 	88 	/* bottom of fifo */
#define REG_OPABDR 	89


#define LAST_DISPLAY	REG_OPABDR+1

/* OnCE register set offsets used by OnCE_rd and OnCE_wr in admdvr.c */

#define 	OSCR	0	/* status and control */
#define 	OMBC	1	/* break ctr. */
#define 	OTC		2	/* trace ctr. */
#define 	OMULR	3	/* breakpoint address */
#define 	OMLLR	4	/* breakpoint address */
#define 	GDB		5	/* global data bus */
#define 	PDB		6	/* program data bus */
#define 	PABF	7	/* program address bus fetch */
#define 	PIIB	8	/* program instruction bus */
#define 	PAB0	9	/* program address bus FIFO inc */
#define 	PAB1	10	/* program address bus FIFO inc */
#define 	PAB2	11	/* program address bus FIFO inc */
#define 	PAB3	12	/* program address bus FIFO inc */
#define 	PAB4	13	/* program address bus FIFO inc */
#define 	PABD	14	/* program address bus decode */



/* DEFINITIONS ASSOCIATED WITH MEMORY AND REGISTER FLAGS */
#define MEM_P 200 /* P MEMORY MAP FLAG FOR MEMORY FETCHES  */
#define MEM_X 201 /* X MEMORY MAP FLAG FOR MEMORY FETCHES */
#define MEM_Y 202 /* Y MEMORY MAP FLAG FOR MEMORY FETCHES */
#define MEM_L 203 /* L MEMORY MAP FLAG FOR MEMORY FETCHES */
#define MEM_T 204 /* T MEMORY MAP FLAG FOR MEMORY FETCHES */
#define MEM_PI 207 /* P MEMORY INTERNAL FLAG */
#define MEM_PE 208 /* P MEMORY EXTERNAL FLAG */
#define MEM_XI 212 /* X MEMORY INTERNAL FLAG */
#define MEM_XE 213 /* X MEMORY EXTERNAL FLAG */
#define MEM_YI 214 /* Y MEMORY INTERNAL FLAG */
#define MEM_YE 215 /* Y MEMORY INTERNAL FLAG */
#define MEM_LI 216 /* Y MEMORY INTERNAL FLAG */
#define MEM_LE 217 /* Y MEMORY INTERNAL FLAG */

/* DEFINITIONS FOR COMMAND CONVERTER COMMANDS */
#define		BPSET     0x0d		 /* break write */
#define 	TRACIMED  0x0e 		 /* trace immediate */
#define         TRACDLY   0x0f 		 /* trace delayed */
#define 	EXECIMED  0x10		 /* go immediate */
#define 	EXECDLY   0x11		 /* go multiple  */
#define 	PREAD	  0x12		 /* pmem read */
#define 	PWRITE	  0x13		 /* pmem write */
#define 	XREAD	  0x14		 /* xmem read */
#define 	XWRITE	  0x15		 /* xmem write */
#define 	YREAD	  0x16		 /* ymem read */
#define 	YWRITE	  0x17		 /* ymem write */
#define 	RREAD	  0x18		 /* reg read */
#define 	RWRITE	  0x19		 /* reg write */
#define 	PWRITES   0x1a		 /* pmem multiple writes */
#define 	XWRITES   0x1b		 /* xmem multiple writes */
#define 	YWRITES   0x1c		 /* ymem multiple writes */
/* DEFINITIONS FOR COMMAND CONVERTER OnCE COMMANDS */
#define 	OREG_RD   0x1d		 /* read OnCE registers */
#define 	OREG_WR   0x1e		 /* write OnCE registers */
#define 	SEQTRACE  0x1f		 /* trace OnCE sequence */
#define 	SEQEXEC   0x20		 /* execute OnCE sequence */
#define 	PIPE_RD   0x21		 /* read pipeline regs. */
#define 	SEQREAD   0x22		 /* read OnCE sequence */
#define 	SEQWRITE  0x23		 /* write OnCE sequence */
#define 	MISC_RD   0x24		 /* misc. reg. read */
#define 	MISC_WR   0x25		 /* misc. reg. write */
#define 	OFORCER   0x26		 /* force reset on converter/DSP56 */
#define 	OFORCEB   0x27		 /* force break on converter/DSP56 */
/* SPECIAL COMMAND FOR SOFTWARE BREAK WRITES-NOT USED BY COMMAND CONVERTER */
#define 	ADSRESET  0x80		 /* evb_reset flag set */
#define 	ADSNMI	  1		 /* evb_brk flag set */

/*	EVM_STAT.GOCMDS[] FLAG	   */
#define 	MONITOR_MODE   	0		/* idle mode 	*/
#define 	GO_MODE	  		1		/* go mode 		*/
#define 	TRACE_MODE	  	2		/* trace mode 	*/
#define 	STEP_MODE	  	4		/* step mode 	*/
#define		NEXT_MODE		5		/* next mode	*/
#define		UNTIL_MODE		6		/* until mode	*/
#define		FINISH_MODE		7		/* finish mode	*/
#define 	STARTUP_MODE	8		/* startup mode */

#define 	OSTATUS   0		/* command conv. x mem. addr of status */
#define 	CSTATUS   3
#define 	WFLAG	  1		/* command conv. x mem. addr. of flag */
#define 	WPTR	  2		/* command conv. x mem. addr. of ptr */

/* OPCODE FOR SOFTWARE BREAKPOINTS */
#define 	DEBUG	  0x200l	/* debug always opcode */

/* OPCODE FOR LONG JUMP */
#define        LONGJUMP   0xaf080l

/* Register types for reg_read and reg_write */
#define        CORE_REG            0
#define        MEM_MAPPED_REG      1
#define        ONCE_REG            2
#define        COUNTER             3
#define        PROG_COUNT          4
#define        STACK_REG           5
#define        DNN                 6
#define        DNS                 7
#define        DND                 8
#define        DML		   9



/* Defines for OnCE Status and Control Register bits */

#define	OSCR_BC0	0x0001l
#define	OSCR_BC1	0x0002l
#define	OSCR_BC2	0x0004l
#define	OSCR_BC3	0x0008l
#define	OSCR_TME	0x0010l
#define	OSCR_SWO	0x0100l
#define	OSCR_MBO	0x0200l
#define	OSCR_TO		0x0400l

#define OSCR_HW_HIT	OSCR_MBO
#define OSCR_SW_HIT	OSCR_SWO



/*
 *   GLOBAL STRUCTURES
 */
struct mac_pkt{
	char macfn[256]; /* macro filename */
	long macpos; /* position in file */
	struct mac_pkt *macprev; /* pointer to previous macro on stack */
    };
struct	 window    {	/* VIRTUAL SCREEN POINTERS */
	int next,head,tail;
	char *dbuf[100];
    };
struct hlptype { int index;   /* current index within display */
		 char **mhlp; /* pointer to main helplines */
		 char *qhelp;	 /* when you type question mark */
	     };
struct dsply_on {	/* DOUBLE LINKED LIST FOR MEMORY DISPLAY ENABLE */
	struct dsply_on *mem_last;
	unsigned long  mem_strt;/* memory block start */
	unsigned long  mem_end; /* memory block end */
	int	asciiflg;	/* if flag=1  display ascii equivalent */
	struct dsply_on *mem_next;
    };
struct load {
	unsigned long value[LOADBUF * DSP_NUMBYTES];
	};
struct	evm_stat     {	   /* SUMMARY OF EVM STATUS */
	int	mainevb;   /* default ADS */
	int	ctrlbr;    /* control C flag */
	int	radix;	   /* default radix */
	int	irq;	   /* pc irq number */
	int	pcio;	   /* pc interface card address */
	int	insert;    /* insert mode flag */
	int	nest;	   /* nesting counter */
	int	pc_irq;    /* ADS interrupt enable flag */
	/* pc irq old address */
	union	laddr { long address; int (*fctn) (); } fctaddr;
	int	host_prt;  /* host serial port */
	int	host_esc;  /* host escape character */
	int	host_echo; /* host echo flag */
	union	laddr host_vec; 		/* pc irq old address */
	char	help_path[256];			/* help file path */
	FILE	*cfilptrs[MAXADS];		/* log command file pointers */
	char	cfilname[MAXADS][256];	/* log command file names */
	FILE	*sfilptrs[MAXADS];		/* log session file pointers */
	char	sfilname[MAXADS][256];	/* log session file names */
	unsigned long occ_ctr[MAXADS];	/* occurrance counter for go command */
	int	brk_num[MAXADS];	/* break number for go command */
	int	gomode[MAXADS]; 	/* go mode flag for go,trace,step */
	char	pathwork[MAXADS][256];	/* path string for each ADS */
	int	active[MAXADS]; 	/* active=1/inactive=0 */
	unsigned long disasm[MAXADS];	/* disassemble current pc location */
	int	macnum; 		/* number of stacked macros */
	long	timeout;		/* loop count for ADM handshake */
	int	pcflag[MAXADS]; 	/* any changes to PC flaged to OnCE */
	unsigned long	 PIPE[MAXADS][9]; /* pipeline values */
	int	debugmode[MAXADS];     /* flag indicates if in OnCE mode */
        unsigned long asm_add;          /* current assembly address */
    };
struct nest {
	long neststadd; /* start of loop position in file 0=not defined */
	int	nestspadd; /* end of loop flag 0=not defined  1=defined */
	long nestrep; /* nest repeat count 0=undefined -1=forever */
	struct nest *nestnext; /* further nesting of loop */
    };
struct mdisp { /* describes enable status of a block of memory */
	long menable; /* 0=off, 1=on */
	unsigned long mbegin; /* beginning address of block */
	unsigned long mend;  /* end address of block */
	struct mdisp *mnext; /* next block */
    };


#define  NORMATRB		0x07	   /* normal attribute for ibm-pc */
#define  BOLDATRB		0x0f	   /* high intensity attribute	  */

/* The following defines are for resizing the screen if you wish to
   make it larger than 20 lines on a SUN or system that supports
   greater than the normal PC screen */
#define  SHOWSCREEN		20
#define  CMDLINE		21   /* command line number */
#define  ERRLINE		22   /* error message line */
#define  HELPLINE		23   /* command help line */
#define  FULLINE		80
#define  FULLSCREEN		FULLINE * 24
#define  MAXSCREEN		99   /* maximum screen scroll size */

/* Function declarations */

char *alloc();  /* memory allocation function */
void *malloc();  /* memory allocation function */


/* Command numbers moved from parse.h */


#define ASSEMBLI        0
#define ASSEMBLS        1
#define BREAKDEFINE     2
#define BREAKENABLE     3
#define BREAKREMOVE     4
#define BREAKLIST       5
#define CHANGERI        6
#define CHANGEMI        7
#define CHANGERM        8
#define DEVICE          9
#define DISASM          10
#define DISPNOWE        11
#define DISPNOW         12
#define DISPENABLE      13
#define DISPAENAB       14
#define DISPREV         15
#define DISPWORK        16
#define EVALUATE        17
#define FORCER          18
#define FORCEB          19
#define GOADDR          20
#define GORESET         21
#define GOCONTINUE      22
#define HELP            23
#define INPUTLST        24
#define INPUTOFF        25
#define INPUTT          26
#define INPUTF          27
#define LOADMEM         28
#define LOADSTATE       29
#define LOGLIST         30
#define LOGOFF          31
#define LOGON           32
#define MOVEMEM         33
#define OUTPUTLST       34
#define OUTPUTOFF       35
#define OUTPUTT         36
#define OUTPUTF         37
#define PATHLST         38
#define PATHCMD         39
#define PCLST           40
#define PCIRQ           41
#define PCIO            42
#define QUIT            43
#define RADIXLST        44
#define RADIXSET        45
#define SAVESTATE       46
#define SAVEMEM         47
#define STEPINST        48
#define SYSTEMU         49  /*SYSTEM COMMAND NAME UNSPECIFIED*/
#define SYSTEMS         50 /*SYSTEM COMMAND NAME SPECIFIED*/
#define TRACEINST       51
#define WAITCMD         52

#define MACRO           53 /* change loadcmds define if this value changes */
#define COMMENTC        54

#define CCHANGE         55 /* command converter change sequence memory */
#define CDISPLAY        56 /* command converter display sequence memory */
#define CFORCE          57 /* command converter force reset/irq */
#define CGO             58 /* command converter run sequence memory */
#define CLOAD           59 /* command converter load sequence memory */
#define CSAVE           60 /* command converter save sequence memory */
#define CSTEP           61 /* command converter step sequence memory */
#define CTRACE          62 /* command converter trace sequence memory */
#define VIEW			63
#define LISTCUR			64
#define LISTPRE			65
#define LISTNXT			66
#define LISTLIN			67
#define LISTADD			68
#define NEXTCOM			69
#define UNTIL			70
#define FINISH			71

