
#include "..\dtc2.h"
#include <bios.h>
#include <dir.h>

#define DEBUG	1
#define USEASM	1

unsigned long *DSPBUF;
int in_debug_mode=0;
int HWxmode,bootmode,Resetp,LoadFile,StopMon;
char lodfile[256];
unsigned lowestP;

OnCEregs Oregs;
DSPregs  Dregs;

char far *QRAM;

ulong bk_hi=0,bk_lo=0,bk_cnt=0;
int   isbk=0;

/*
	01	bf	break on fetch
	02	bpf	break on P read/fetch
	03	bpa	break on P access
	04	bfe	break on executed fetches
	05	bpw	break on P write
	06	bpr	break on P read
	07	bp	break on P read/write
	09	bxw	break on X write
	0a	bxr	break on X read
	0b	bx	break on X read/write
	0d	byw	break on Y write
	0e	byr	break on Y read
	0f	by	break on Y read/write
*/
/* ----------------------------------------------------------------- */


ulong kRDP(ushort a,int n)
{
 ulong v;
  OnCErmem('p',a+n,1,&v);
  return(v);
}


/* ----------------------------------------------------------------- */


static ulong getvnum(char *p)
{
 char *s;
 int sgn;
 ulong v;
 double d,dk=8388608.0;

  s=p; sgn=0;
  if (*s=='-') {sgn=1; s++;}
  switch(*s) {
    case '$':
    case '#': return (sscanf(s+1,"%lx",&v)==1? v:-1l);
    case '0': if (s[1]=='x') {
		return (sscanf(s+2,"%lx",&v)==1? v:-1l);
	       }
	      if (s[1]!='.') goto stdnum;
    case '.': if (sscanf(s,"%lf",&d)!=1) return(-1l);
	      if (d >= 1.0) d=0.9999999;
	      if (sgn) d = -d;
	      v=d*dk; return(v);
stdnum:
    default : if (s[strlen(s)-1]=='h') {
		s[strlen(s)-1]=0;
		if (sscanf(s,"%lx",&v)!=1) return(-1l);
		return((sgn? -v:v)&0xffffffl);
	       }
	      if (sscanf(s,"%ld",&v)==1) {
		return((sgn? -v:v)&0xffffffl);
	       }
	      else {
		if (sscanf(s,"%lx",&v)!=1) return(-1l);
		return((sgn? -v:v)&0xffffffl);
	       }
   }
}


/* ----------------------------------------------------------------- */


static int parseadd(char *p,char *space,ulong *a)
{
 char c;
 ulong v;

  if (p && *p) {
    c=tolower(*p);
    if ((c=='x')||(c=='y')||(c=='p')) {
      p++; if ((*p++)!=':') return(1);
      *space=c;
     }
    else if (!isxdigit(c)) return(1);
    if (sscanf(p,"%lx",&v)==1) *a=v;
   }
  return(0);
}



int monitor(int res)
{
 static char Sep[] = "\t\r\n ,";
 char cmlin[128];
 char *p,*p1;
 char ms='p',lastms='p',cmd='r',lastcmd='r';
 int i,j,n,lastn=64,be,err,dft;
 ulong A,a=0,lasta=0,v,lastt=1;

  if (err=begin_debug_run(&Oregs,res)) return(err);

  if (LoadFile) {
    if (OnCEloadDSP(lodfile,DSPBUF)==1) goto quit;
    A=lowestP;
   }
  else A=0xffff;

  for (;;) {
    printf(">");
    gets(cmlin);
    p=strtok(cmlin,Sep);

    cmd = (p? tolower(*p):lastcmd);

    switch(cmd) {
      case 'q': goto quit;

      case 'b': if (p[1]==0) {
		  if (isbk) {
		    printf("BR %d at (%06lx-%06lx) for %d\n",isbk,bk_lo,
			bk_hi,bk_cnt);
		   }
		  else
		    printf("No breakpoints\n");
		 }
		else {
		  be=0;
		  switch(tolower(p[1])) {
		    case 'f': switch(tolower(p[2])) {
				case 'e': isbk=4; break;
				case  0 : isbk=1; break;
				default : be=1;
			       }
			      break;
		    case 'p': switch(tolower(p[2])) {
				case 'a': isbk=3; break;
				case 'f': isbk=2; break;
				case 'r': isbk=6; break;
				case 'w': isbk=5; break;
				case  0 : isbk=7; break;
				default : be=1;
			       }
			      break;
		    case 'x': switch(tolower(p[2])) {
				case 'r': isbk=10; break;
				case 'w': isbk=9; break;
				case  0 : isbk=11; break;
				default : be=1;
			       }
			      break;
		    case 'y': switch(tolower(p[2])) {
				case 'r': isbk=14; break;
				case 'w': isbk=13; break;
				case  0 : isbk=15; break;
				default : be=1;
			       }
			      break;
		    default : be=1; break;
		   }
		  if (be) {
		    printf("Invalid break code - %s\n",p);
		    isbk=0; break;
		   }
		  bk_cnt=1; bk_lo=0; bk_hi=0xffff;
		  p=strtok(NULL,Sep);
		  if (p && (sscanf(p,"%x",&i)==1)) {
		    bk_lo=i;
		    p=strtok(NULL,Sep);
		    if (p && (sscanf(p,"%x",&i)==1)) {
		      bk_hi=i;
		      p=strtok(NULL,Sep);
		      if (p && (sscanf(p,"%d",&i)==1)) bk_cnt=i;
		     }
		    else {
		      bk_hi=bk_lo;
		      if (p && (sscanf(p,"%d",&i)==1)) bk_cnt=i;
		     }
		   }
		 }
		break;

      case 'g': if (!isbk) {
		  OnCEdebgo(&Oregs);
		  goto shwreg;
		 }
		else {
		  OnCEbrkgo(&Oregs);
		  goto shwreg;
		 }
		break;

      case 't': p=strtok(NULL,Sep);
		if (sscanf(p,"%ld",&v)!=1) v=lastt;
		if (err=OnCEtrace(&Oregs,v,A)) {
		  printf("Error %d in trace\n",err);
		  goto quit;
		 }
		lastt=v;
		A=0xffff;	/* fall through */
      case 'r': p=strtok(NULL,Sep);
		if (p==NULL) {
shwreg:
		  OnCEgetallreg(&Dregs,0xffffffffl);
		  OnCEshowallreg(&Dregs,&Oregs,stdout);
		 }
		else OnCEgetregn(p,stdout);
		break;

      case 'c': p=strtok(NULL,Sep);
		if (p!=NULL) {
		  p1=strtok(NULL,Sep);
		  if (p1 && (v=getvnum(p1))!= -1l) {
		    OnCEputregn(p,v);
		   }
		 }
		break;

      case 'v':
      case 'd': p=strtok(NULL,Sep);
		a=lasta; ms=lastms;
		if (!parseadd(p,&ms,&a)) {
		  if (cmd=='d') {
		    p=strtok(NULL,Sep);
		    if (p && (sscanf(p,"%x",&i)==1)) n=i; else n=lastn;
		   }
		  else n=1;
		  OnCErmem(ms,a,n,DSPBUF);
		  lasta=a+n; lastms=ms;
		  if (cmd=='d') lastn=n;
		  i=0; j=0;
		  while (n--) {
		    if (j==0) printf("%c:%04x ",toupper(ms),a);
		    printf(" %06lx",DSPBUF[i++]&0xffffff);
		    j++; a++;
		    if (j==8) { printf("\n"); j=0; }
		   }
		  if (j) printf("\n");
		 }
		break;

      case 'f': p=strtok(NULL,Sep);
		a=lasta; ms=lastms;
		if (!parseadd(p,&ms,&a)) {
		  p=strtok(NULL,Sep);
		  if (p && (sscanf(p,"%x",&i)==1)) n=i; else n=1;
		  p=strtok(NULL,Sep);
		  if (p && (sscanf(p,"%lx",&v)!=1)) v=0;
		  OnCEfillmem(ms,a,n,v);
		  lasta=a+n; lastms=ms;
		 }
		break;

      case 'u': p=strtok(NULL,Sep);
		a=lasta; ms=lastms;
		if (!parseadd(p,&ms,&a)) {
		  for (i=0; i<10; i++) {
		    a+=disasm56(a,kRDP,stdout);
		   }
		  lasta=a; lastms=ms;
		 }
		break;

      case 'w': p=strtok(NULL,Sep);
		a=lasta; ms=lastms;
		if (!parseadd(p,&ms,&a)) {
		  p=strtok(NULL,Sep);
		  if (p && (sscanf(p,"%lx",&v)==1)) {
		    OnCEwmem(ms,a,1,&v);
		    lasta=a+n; lastms=ms;
		   }
		 }
		break;

      case 'z': outportb(oDRES,0);	/* emergency exit */
		delay(1);
      		outportb(oDMODE,1);
		outportb(oDRES,1);
		return(1);

      default:	printf("<R>egister dump      <T>race n\n");
		printf("<R>egister {reg}     <C>hange reg val\n");
		printf("<D>ump s:addr n      <F>ill s:addr n val\n");
		printf("<W>rite s:addr val   <V>iew s:addr\n");
		printf("<G>o                 <Q>uit\n");
		break;
     }
    lastcmd=cmd;
   }
quit:
  if (err=end_debug(&Oregs)) printf("Exit error %d\n",err);

  return(0);
}


/* ------------------------------------------------------------------- */


void params (int argc,char *argv[])
{
 char *p;

  LoadFile=0; Resetp=0; bootmode=0;
  StopMon=0;

  while (--argc) {
    p=argv[argc];
    if ((*p=='-')||(*p=='/')) {
      switch(tolower(p[1])) {
	case 's': StopMon=(p[2]!='-'); break;
	case 'm': bootmode=(p[2]!='-'); break;
	case 'r': Resetp=(p[2]!='-'); break;
	default:  break;
       }
     }
    else {
      strcpy(lodfile,p); LoadFile=1;
     }
   }
}


/* ------------------------------------------------------------------- */


int main (int argc,char *argv[])
{
 int i,t,cont;

  params(argc,argv);

  DSPBUF=(unsigned long *)malloc(DBUFSIZ*sizeof(long));
  if (DSPBUF==NULL) exit(-1);
  memset(DSPBUF,0xff,DBUFSIZ*sizeof(long));

  if (!DTC2present(&QRAM)) {
    printf("DTC2 not found\n");
    exit(1);
   }

  if (LoadFile) {
    Resetp=StopMon=0;
    outportb(oDRES,0);
    outportb(oDMODE,0);
    delay(1);
    outportb(oDRES,1);
    if (OnCEfakeboot()) goto quit;
   }
  else {
    cont=OnCEreq();
    if (StopMon&&(!cont)) {
      t=100; QRAM[0x341]=0x80;
      do delay(1); while ((QRAM[0x341]==0x80)&&(--t));
      if (t==0) { Resetp=1; goto quit; }
      if ((QRAM[0x341]==0)&&OnCEreq()) cont=1;
     }
   }

#if (0)
  if (!cont) {
    outportb(oDMODE,bootmode);
    if (!Resetp) {
      outportb(oDRES,1);	/* start DSP if reset */
      if (bootmode) delay(500);
      if (fakeboot()) goto quit;
     }
   }
#endif

  monitor(Resetp);

quit:
  if (Resetp)
    outportb(oDRES,0);	/* reset DSP  */
  return(0);
}

