
; ===================================================================

DTCMon 	ident	1,0
	page	120,60,1,1,4
	opt	cc,cex,intr,mc,md,mex
	lstcol	10,,,,

; ===================================================================
	INCLUDE		'..\glob56.asm'
; ===================================================================
;
CLK56	equ	60		; MHz
PLLMUL	equ	(CLK56/5)-1
TIMDIV	equ	(CLK56*50)	; to get 100us on timer

; ===================================================================
;
; L: variables
;
L_savA0		equ	0
L_timr		equ	1

; X: variables
;
XTEMP		equ	8
X_tf		equ	9
X_pend		equ	10
XP_ch1		equ	11
XP_ch2		equ	12
XP_ch3		equ	13
XP_ch4		equ	14

; X: variables
;
YTEMP		equ	8
Y_cycl		equ	9
Y_adc		equ	10
Y_dac		equ	11

; ===================================================================

NULLVEC		macro
		nop
		nop
		endm

ERRVEC		macro
		jsr	>ERROR
		endm

;
; reset loc: byte 0 block 3 Flash (0c000 = P:c000)
;	order: L-M-H, 3 bytes/word
;
	ORG	P:0		; bootstrap from host port

VReset	jmp	>START1
VStkerr	ERRVEC
VTrace	ERRVEC
VSWI	ERRVEC
VIRQA	NULLVEC
VIRQB	NULLVEC
VSSIr   NULLVEC
VSSIrx  NULLVEC
VSSIt   NULLVEC
VSSItx	NULLVEC
VSCIr	NULLVEC
VSCIrx	NULLVEC
VSCIt	NULLVEC
VSCIi	NULLVEC
VSCItim	NULLVEC
VNMI	NULLVEC
VHOSTR	ERRVEC
VHOSTT	ERRVEC

VHOSTC	jsr	>PEEK		; 0024	V=$12
; host aux vectors @ P:0026-003E
VHC1	jsr	>POKE		; 0026
VHC2    jsr	>FILL

VHC3    jsr	>HOSTC3		; 002a
VHC4    jsr	>HOSTC4
VHC5    jsr	>HOSTC5
VHC6    jsr	>HOSTC6		; 0030	V=$18
VHC7    jsr	>HOSTC7
VHC8    jsr	>HOSTC8
VHC9    jsr	>HOSTC9
VHC10   jsr	>HOSTC10
VHC11   jsr	>HOSTC11
VTIMER	NULLVEC
;	jsr	>TIMER		; 003c	V=$1e

VILLEG  jsr	>ILLOP		; 003e

; ===================================================================
;
; Error processing
;
ILLOP	equ	*
;	move	#$ee,m7
;	move	m7,Y:$c340
ERROR   equ	*
;	ori     #3,MR           ; no IRQs
	debug
	jmp	*

; ===================================================================

; wait 64k*33n = 2.16msec
WAIT1	clr	a
	rep	a1
	nop
	rts

; ===================================================================

HOSTC3	equ	*
HOSTC4	equ	*
HOSTC5	equ	*
HOSTC6	equ	*
HOSTC7	equ	*
HOSTC8	equ	*
HOSTC9	equ	*
HOSTC10	equ	*
HOSTC11	equ	*
HOSTC12	equ	*
HOSTCX	equ	*
	rti

; ===================================================================
;
;TIMER	equ	*
;	move	a10,L:<L_savA0
;	move	L:<L_timr,a10
;	inc	a
;	move	a10,L:<L_timr
;	move	L:<L_savA0,a10
;	rti
;
; ===================================================================

; Get a word from Host Port into A1
;
GETWORD	jclr	#M_HRDF,X:<<M_HSR,GETWORD
	movep	X:<<M_HRX,a1
	rts

;
; Put a word from X0 into Host Port
;
PUTWORD	jclr	#M_HTDE,X:<<M_HSR,PUTWORD
	movep	x0,X:<<M_HTX
	rts

Pkpoka	jsr     <GETWORD		; get space/address <SSAAAA>
	tfr	a,b	a1,X:<XTEMP
	jsr	<GETWORD		; get word count
	move	a1,n0
	move	b1,r0
	rts

;
; PEEK: put block from S:A into Host Port
;
PEEK    equ     *
	jsr     <Pkpoka
	do	n0,Endpeek
	jset	#PP_REG,X:<XTEMP,PeekPE
	jset	#PP_MP,X:<XTEMP,PeekPE
	jset	#PP_MXY,X:<XTEMP,PeekY
PeekX   move    X:(r0)+,x0
	jmp	<Epeek0
PeekY   move    Y:(r0)+,x0
	jmp     <Epeek0
PeekPE	movem   P:(r0)+,x0
Epeek0	jsr     <PUTWORD
	nop
Endpeek	rti

;
; POKE: get block from Host Port into S:A
;
POKE    equ     *
	jsr     <Pkpoka
	do	n0,Endpoke
	jsr     <GETWORD		; get value into A1
	jset	#PP_REG,X:<XTEMP,PokePE
	jset	#PP_MP,X:<XTEMP,PokePE
	jset	#PP_MXY,X:<XTEMP,PokeY
PokeX   move    a1,X:(r0)+
	jmp	<Epoke0
PokeY   move    a1,Y:(r0)+
	jmp	<Epoke0
PokePE	movem   a1,P:(r0)+
Epoke0	nop
Endpoke	rti

;
; FILL: fill block from Host Port into S:A
;
FILL    equ     *
	jsr     <Pkpoka
	jsr     <GETWORD		; get value into A1
	do	n0,Endfill
	jset	#PP_REG,X:<XTEMP,Efill0
	jset	#PP_MP,X:<XTEMP,FillPE
	jset	#PP_MXY,X:<XTEMP,FillY
FillX   move    a1,X:(r0)+
	jmp	<Efill0
FillY   move    a1,Y:(r0)+
	jmp	<Efill0
FillPE	movem   a1,P:(r0)+
Efill0	nop
Endfill	rti

; ===================================================================
;
CODECREG	macro	REG
	movep	#(REG<<8),Y:<<C_IAR
	nop
	endm

CODECDAT	macro	DST
	movep	Y:<<C_IDR,DST
	nop
	endm

CodecXwrite	equ *		; WARNING wait states!
	movep	r0,Y:<<C_IAR
	rep	#6
	nop
	movep	x0,Y:<<C_IDR
	rep	#6
	nop
	rts

CodecXread	equ *		; WARNING wait states!
	movep	r0,Y:<<C_IAR
	rep	#6
	nop
	movep	Y:<<C_IDR,x0
	rep	#6
	nop
	rts

YWRITEA	equ	*
	movep	a1,Y:<<Y_ADRW
	rep	#100		; 3.3u
	nop
	rts

YWRITED	equ	*
	movep	a1,Y:<<Y_DATW
	rep	#700		; 23u
	nop
	rts

YREADS 	equ	*
	movep	Y:<<Y_STAT,x0
	rep	#20
	nop
	rts

; ===================================================================
;
; PLL after reset: ckin=5MHz
;
START1  equ     *
	ori     #3,MR           ; no IRQs
	move	#>($1F0000|PLLMUL),x0	; ck*12 = 60 MHz
	movep	x0,X:<<M_PCTL
	nop
	movec	#$40,omr
	movec	#0,sp
	movep	#$1144,X:<<M_BCR
	movep   #0,X:<<M_HCR
	movep   #0,X:<<M_PBD
	movep   #0,X:<<M_PCC
	bset    #1,X:<<M_PBC    ; (re-)enable HI, PB14 I/O
	ori     #3,MR           ; no IRQs
	movec	#0,SP
	andi    #3,MR
;
; Flash addresses
;			INVERTED OUT!	<<8!
;	00000-03FFF	SC0=1 SC1=1	OR1=3	P:$C000-$FFFF
;	04000-07FFF	SC0=0 SC1=1	OR1=2	P:$C000-$FFFF
;	08000-0BFFF	SC0=1 SC1=0	OR1=1	P:$C000-$FFFF
;	0C000-0FFFF	SC0=0 SC1=0	OR1=0	P:$C000-$FFFF
;	10000-13FFF	SC0=1 SC1=1	OR1=3	X:$C000-$FFFF
;	14000-17FFF	SC0=0 SC1=1	OR1=2	X:$C000-$FFFF
;	18000-1BFFF	SC0=1 SC1=0	OR1=1	X:$C000-$FFFF
;	1C000-1FFFF	SC0=0 SC1=0	OR1=0	X:$C000-$FFFF
;
	move	#0,r0
	clr	a
	rep	#256
	move	a,L:(r0)+

; -------------------------------------------------------
;	Configure SCI for ()B, N81
;	System clock is 60.000 MHz
;	Ext.clock is 8.000 MHz
;
; X:SCR [13=TMIE 12=TIE 11=RIE 10=ILIE 9=TE 8=RE 7=WOMS 6=RWU 5=WAKE
;         4=SBK  2-0=WDS]
;
; ========== SCI ==================================
; internal ck= 16*BR
; in ck = 30.0 MHz
; SCLK out = BR
; SCCR value = (ck/64)/BR
; BPS = (f0/64) / ((SCP?8:1)*(CD+1))
;
; -------------------------------------------------------

	movep	#$0,X:<<M_PCDDR
	movep	#$0026,X:<<M_SCR	; EXT CK - WDS=010(8N1)
	movep	#$c002,X:<<M_SCCR	; EXT CK - Scale=/3 -> 250 kHz

; CRA: PSR WL(2) DC(5)  PM(8)
;       0   10   0.0000.0000.0000
	movep	#$4000,X:<<M_CRA
; CRB: RIE TIE RE TE MOD GCK SYN FSL(2) SHFD SCD(4) OF(2)
;	0   0   0  0. 0   1   1   1.0    0   00.00   00
	movep	#$0700,X:<<M_CRB

; --------------------------------------------
;
; IRQ priorities:
;	TIMER= disabled
;	SCI  = disabled
;	SSI  = disabled
;	HOST = level 1 (10)
;	IRQB = disabled, edge trig (100)
;	IRQA = disabled, edge trig (100)
;
;               rr rr rr TT CC SS HH rr rr BB B AAA
;               -----------------------------------
; bit setting = xx.xx|xx.00|00.00|10.xx|xx.10|0.100

	movep	#>$000824,X:<<M_IPR
	movep	#>$1114,X:<<M_BCR
	nop

; ===================================================================
;
; peripherals on U43 use bits 8-15 !!
;
	move	#UART1,r0
	jsr	<INIT_U
	move	#UART2,r0
	jsr	<INIT_U
	move	#UART3,r0
	jsr	<INIT_U
	move	#UART4,r0
	jsr	<INIT_U

	MEM_MODE1			; set memX!=memY
	clr	a	#QRUART,r0
	bset	#U_SCO7,Y:<<U_OR4	; start AD1848
	move	a,Y:$E008		; clear FPGA register
	move	a,X:<X_pend
	rep	#8			; C338..C33F
	move	a,Y:(r0)+		; clear alternate UART1/2 regs
	rep	#16			; C340..C34F
	move	a,Y:(r0)+		; clear QRAM Host port & co.
;
; CodecInit (a)
;
	movep	#>$111a,X:<<M_BCR
	nop
	nop
_u0la	jclr	#15,Y:<<C_IAR,_u1la	; wait for init
	nop
	nop
	jmp	<_u0la
_u1la	nop
;
; CodecInit (b)
;
	move	#0,r0
	move	#$100,n0		; next reg <<8
	move	#0,x0
	jsr	<CodecXwrite		; 0,0
	move	(r0)+n0
	jsr	<CodecXwrite		; 1,0
	move	(r0)+n0
	move	#>$8000,x0
	jsr	<CodecXwrite		; 2,$80
	move	(r0)+n0
	jsr	<CodecXwrite		; 3,$80
	move	(r0)+n0
	jsr	<CodecXwrite		; 4,$80
	move	(r0)+n0
	jsr	<CodecXwrite		; 5,$80
	move	(r0)+n0
	jsr	<CodecXwrite		; 6,$80
	move	(r0)+n0
	jsr	<CodecXwrite		; 7,$80
	move	(r0)+n0
	move	#>$5c00,x0
	jsr	<CodecXwrite		; 8,$5c
	move	(r0)+n0
	move	#>$0800,x0
	jsr	<CodecXwrite		; 9,$08
	move	(r0)+n0
	move	#0,x0
	jsr	<CodecXwrite		; 10,0
	move	#0,x0
	move	#$d00,r0
	jsr	<CodecXwrite		; 13,0
	move	(r0)+n0
	jsr	<CodecXwrite		; 14,0
	move	(r0)+n0
	move	#>$2000,x0
	jsr	<CodecXwrite		; 15,$20
;
	CODECREG	11
	nop
_u2la	jclr	#13,Y:<<C_IDR,_u3la	; wait for autocalib
	nop
	nop
	jmp	<_u2la
_u3la	nop
;	jsr	<WAIT1
	move	#>$c000,x0
	move	#$a00,r0
	jsr	<CodecXwrite		; 10,$c0

	movep	X:<<M_RX,a1
	movep	X:<<M_RX,a1

; CRB: RIE TIE RE TE MOD GCK SYN FSL(2) SHFD SCKD SCD2-0 OF(2)
;	0   0   1  1. 0   1   1   0.0    0    0    0.00   00
	movep	#$3600,X:<<M_CRB
	movep	#$1c7,X:<<M_PCC

; ===================================================================

	bset    #M_HCIE,X:<<M_HCR    	; set HCIE
	nop
	andi	#$FD,MR			; IRQs lev 1,2 enabled

	movep	#>$0416,X:<<M_BCR
	move	#0,r4

ELOOP	equ	*
;
; get/set AD7869 from Y:c354-7 (a)
;
	move	#$c354,r0
	clr	a
	move	Y:(r0)+,a2
;	rep	#8
;	asr	a
	move	Y:(r0)+,a2
;	rep	#8
;	asr	a			; data: hh.ll.00
	move	a1,Y:<Y_dac
	movep	a1,X:<<M_TX
	movep	#0,Y:<<AD7869		; dummy
;
; get/set AD7869 from Y:c354-7 (b)
;
	rep	#800
	nop
	move	#$c356,r0
	jclr	#M_RDF,X:<<M_SR,_eloo5
	movep	X:<<M_RX,x0
	debug
	move	x0,Y:<Y_adc
_eloo5	move	Y:<Y_adc,x0
	mpy	x0,#8,a
	move	a1,Y:(r0)+
	mpy	x0,#16,a
	move	a1,Y:(r0)+

	move	(r4)+
	jmp     <ELOOP


; ===================================================================
;
; Init UARTs for communication - r0=UART base
;
;  for (k=0; k<0x100; k++) {
;    *COM1_scratchpad=k;
;    if (*COM1_scratchpad!=k) return(0);
;   }
;  *COM1_scratchpad=1;
;
;  *COM1_line_ctrl=0x83;
;  *COM1_baudL=MIDIBAUD;
;  *COM1_baudH=0;
;  *COM1_modem_ctrl=0;
;  *COM1_line_ctrl=0x03;
;  k=*COM1_data;
;  k=*COM1_line_stat;
;
;  *COM1_modem_ctrl=0x10;	/* loopback */
;  for (k=0; k<0x100; k++) {
;    *COM1_data=k;
;    wait(8);
;    if (*COM1_data!=k) return(0);
;   }
;  *COM1_modem_ctrl=0;
;  return(1);
;
; peripherals on U43 use bits 8-15 !!
;
INIT_U	equ	*
	movep	X:<<M_BCR,x1		; save
	movep	#>$1116,X:<<M_BCR
	move	#U_LCR,n0
	move	#>$8300,y0		; DLAB=1
	move	y0,Y:(r0+n0)
	move	#U_DLL,n0
	move	#>$1000,y0		; baudL = 16 for 8MHz
	move	y0,Y:(r0+n0)
	move	#U_DLM,n0
	move	#0,y0			; baudH
	move	y0,Y:(r0+n0)
	move	#U_FCR,n0
	move	#>$0100,y0
	move	y0,Y:(r0+n0)
	move	#U_MCR,n0
	move	#0,y0
	move	y0,Y:(r0+n0)
	move	#U_LCR,n0
	move	#>$0300,y0		; DLAB=0
	move	y0,Y:(r0+n0)
	move	#U_RBR,n0
	nop
	move	Y:(r0+n0),y0
	move	#U_LSR,n0
	nop
	move	Y:(r0+n0),y0
	movep	x1,X:<<M_BCR
	rts

; ===================================================================

	end

