
; ===================================================================

ADtest 	ident	1,0
	page	120,60,1,1,4
	opt	cc,cex,intr,mc,md,mex
	lstcol	10,,,,

; ===================================================================
	INCLUDE		'..\glob56.asm'
; ===================================================================
;
; X: variables
;
Tdata		equ	0
TEMP		equ	1
IsNMI		equ	2

; ===================================================================

NULLVEC		macro
		nop
		nop
		endm

ERRVEC		macro
		jsr	>ERROR
		endm


	ORG	P:0		; bootstrap from host port

VReset	jmp	>START1		; 0000
VStkerr	ERRVEC
VTrace	ERRVEC
VSWI	ERRVEC
VIRQA	NULLVEC
VIRQB	NULLVEC
VSSIr   NULLVEC
VSSIrx  NULLVEC
VSSIt   NULLVEC
VSSItx	NULLVEC
VSCIr	NULLVEC
VSCIrx	NULLVEC
VSCIt	NULLVEC
VSCIi	NULLVEC
VSCItim	NULLVEC
VNMI	NULLVEC
VHOSTR	ERRVEC
VHOSTT	ERRVEC

VHOSTC	jsr	>PEEK
; host aux vectors @ P:0026-003E
VHC1	jsr	>POKE		; 0026
VHC2    jsr	>FILL

VHC3    NULLVEC
VHC4    NULLVEC
VHC5    NULLVEC
VHC6    NULLVEC
VHC7    NULLVEC
VHC8    NULLVEC
VHC9    NULLVEC
VHC10   NULLVEC
VHC11   NULLVEC
VHC12   NULLVEC

VILLEG  ERRVEC

; ===================================================================

; wait 64k*33n = 2.16msec
WAIT1	clr	a
	rep	a1
	nop
	rts

; ===================================================================

; Get a word from Host Port into A1
;
GETWORD	jclr	#M_HRDF,X:<<M_HSR,GETWORD
	movep	X:<<M_HRX,a1
	rts

;
; Put a word from X0 into Host Port
;
PUTWORD	jclr	#M_HTDE,X:<<M_HSR,PUTWORD
	movep	x0,X:<<M_HRX
	rts

Pkpoka	jsr     <GETWORD		; get space/address <SSAAAA>
	tfr	a,b	a1,X:<TEMP
	jsr	<GETWORD		; get word count
	move	a1,n0
	move	b1,r0
	rts

;
; PEEK: put block from S:A into Host Port
;
PEEK    equ     *
	jsr     <Pkpoka
	do	n0,Endpeek
	jset	#PP_REG,X:<TEMP,PeekPE
	jset	#PP_MP,X:<TEMP,PeekPE
	jset	#PP_MXY,X:<TEMP,PeekY
PeekX   move    X:(r0)+,x0
	jmp	<Epeek0
PeekY   move    Y:(r0)+,x0
	jmp     <Epeek0
PeekPE	movem   P:(r0)+,x0
Epeek0	jsr     <PUTWORD
	nop
Endpeek	rti

;
; POKE: get block from Host Port into S:A
;
POKE    equ     *
	jsr     <Pkpoka
	do	n0,Endpoke
	jsr     <GETWORD		; get value into A1
	jset	#PP_REG,X:<TEMP,PokePE
	jset	#PP_MP,X:<TEMP,PokePE
	jset	#PP_MXY,X:<TEMP,PokeY
PokeX   move    a1,X:(r0)+
	jmp	<Epoke0
PokeY   move    a1,Y:(r0)+
	jmp	<Epoke0
PokePE	movem   a1,P:(r0)+
Epoke0	nop
Endpoke	rti

;
; FILL: fill block from Host Port into S:A
;
FILL    equ     *
	jsr     <Pkpoka
	jsr     <GETWORD		; get value into A1
	do	n0,Endfill
	jset	#PP_REG,X:<TEMP,Efill0
	jset	#PP_MP,X:<TEMP,FillPE
	jset	#PP_MXY,X:<TEMP,FillY
FillX   move    a1,X:(r0)+
	jmp	<Efill0
FillY   move    a1,Y:(r0)+
	jmp	<Efill0
FillPE	movem   a1,P:(r0)+
Efill0	nop
Endfill	rti

; ===================================================================
;
; Error processing
;
ERROR   equ	*
;	bset    #M_HF2,X:<<M_HCR     ; set error flag (HF23 = 11)
;	bset	#M_HF3,X:<<M_HCR
;	ori     #3,MR           ; no IRQs
;	nop
	dc	$200		; debug
	stop
	rti

; ===================================================================
;
CODECREG	macro	REG
	movep	#(REG<<8),Y:<<C_IAR
	nop
	endm

CODECDAT	macro	DST
	movep	Y:<<C_IDR,DST
	nop
	endm

CodecXwrite	equ *		; WARNING wait states!
	movep	r0,Y:<<C_IAR
	rep	#6
	nop
	movep	x0,Y:<<C_IDR
	rep	#6
	nop
	rts

CodecXread	equ *		; WARNING wait states!
	movep	r0,Y:<<C_IAR
	rep	#6
	nop
	movep	Y:<<C_IDR,x0
	rep	#6
	nop
	rts

YWRITEA	equ	*
	movep	a1,Y:<<Y_ADRW
	rep	#100		; 3.3u
	nop
	rts

YWRITED	equ	*
	movep	a1,Y:<<Y_DATW
	rep	#700		; 23u
	nop
	rts

YREADS 	equ	*
	movep	Y:<<Y_STAT,x0
	rep	#20
	nop
	rts

; ===================================================================
;
; PLL after reset: ckin=5MHz
;
START1  equ     *
	move	#>$1F000b,x0	; ck*12 = 60 MHz
	movep	x0,X:<<M_PCTL
	nop
	nop
	movep   #0,X:<<M_HCR
	movep   #0,X:<<M_PBD
	bset    #1,X:<<M_PBC    ; (re-)enable HI, PB14 I/O
	ori     #3,MR           ; no IRQs
	movec	#0,SP
	clr	a
	move	a,X:<IsNMI
	andi    #3,MR
	move	#$FFFF,m0

; @60 MHz	tc=33.3n
;		1W=50.0n
;		2W=66.6n
;		3W=83.3n
;		4W=100.0n

	movep	#$1114,X:<<M_BCR	; X=50n Y=66n P=50n Pe=100n
	move	#0,r0
	clr	a
	rep	#256
	move	a,L:(r0)+

; -------------------------------------------------------
;	Configure SCI for ()B, N81
;	System clock is 60.000 MHz
;	Ext.clock is 8.000 MHz
;
; X:SCR [13=TMIE 12=TIE 11=RIE 10=ILIE 9=TE 8=RE 7=WOMS 6=RWU 5=WAKE
;         4=SBK  2-0=WDS]
;
; ========== SCI ==================================
; internal ck= 16*BR
; in ck = 30.0 MHz
; SCLK out = BR
; SCCR value = (ck/64)/BR
; BPS = (f0/64) / ((SCP?8:1)*(CD+1))
;
; -------------------------------------------------------

	movep	#$0,X:<<M_PCDDR
	movep	#$0026,X:<<M_SCR	; EXT CK - WDS=010(8N1)
	movep	#$c002,X:<<M_SCCR	; EXT CK - Scale=/3 -> 250 kHz

;	movep	#$0002,X:<<M_SCR	; INT CK - WDS=010(8N1)
;	movep	#$001d,X:<<M_SCCR	; INT CK - Scale=/30 -> 31.25 kHz

; CRA: PSR WL(2) DC(5)  PM(8)
;       0   10   0.0000.0000.0000
	movep	#$4100,X:<<M_CRA
; CRB: RIE TIE RE TE MOD GCK SYN FSL(2) SHFD SCD(4) OF(2)
;	0   0   0  0. 0   0   1   0.0    0   00.00   00
	movep	#$0200,X:<<M_CRB

; now activate SCI/SSI
	movep	#$007,X:<<M_PCC

; --------------------------------------------

; IRQ priorities:
;	SCI  = disabled
;	SSI  = disabled
;	HOST = level 1 (10)
;	IRQB = disabled, edge trig (100)
;	IRQA = disabled, edge trig (100)
; bit setting = 00.00|10.xx|xx.10|0.100		(x=0)

	movep	#>$0824,X:<<M_IPR

	movep	#>$1114,X:<<M_BCR
	nop

; ===================================================================
;
; peripherals on U43 use bits 8-15 !!
;
	MEM_MODE0
	nop
	bset	#U_SCO7,Y:<<U_OR4	; start AD1848
	jsr	<WAIT1

	movep	#>$0014,X:<<M_BCR
	nop
	move	#>$1848,x0
	jsr	<PUTWORD

; CodecInit (a)
;
	movep	#>$111a,X:<<M_BCR
;	nop
;	nop
;_u0la	jclr	#15,Y:<<C_IAR,_u1la	; wait for init
;	nop
;	nop
;	jmp	<_u0la
;_u1la	nop

	do	#100,lwait
	jsr	<WAIT1
	nop
lwait	nop
	movep	#$4000,Y:<<C_IAR
;
; CodecInit (b)
;
	move	#0,r0
	move	#$100,n0		; next reg <<8
	move	#0,x0
	jsr	<CodecXwrite		; 0,0
	move	(r0)+n0
	jsr	<CodecXwrite		; 1,0
	move	(r0)+n0
	move	#>$8000,x0
	jsr	<CodecXwrite		; 2,$80
	move	(r0)+n0
	jsr	<CodecXwrite		; 3,$80
	move	(r0)+n0
	jsr	<CodecXwrite		; 4,$80
	move	(r0)+n0
	jsr	<CodecXwrite		; 5,$80
	move	(r0)+n0
	jsr	<CodecXwrite		; 6,$80
	move	(r0)+n0
	jsr	<CodecXwrite		; 7,$80
	move	(r0)+n0
	move	#>$5c00,x0
	jsr	<CodecXwrite		; 8,$5c
	move	(r0)+n0
	move	#>$0800,x0
	jsr	<CodecXwrite		; 9,$08
	move	(r0)+n0
	move	#>$0000,x0
	jsr	<CodecXwrite		; 10,0
	move	#0,x0
	move	#$d00,r0
	jsr	<CodecXwrite		; 13,0
	move	(r0)+n0
	jsr	<CodecXwrite		; 14,0
	move	(r0)+n0
	move	#>$2000,x0
	jsr	<CodecXwrite		; 15,$20
;
	CODECREG	11
	nop
_u2la	jclr	#13,Y:<<C_IDR,_u3la	; wait for autocalib
	nop
	nop
	jmp	<_u2la
_u3la	nop
	jsr	<WAIT1
	jsr	<WAIT1
	jsr	<WAIT1
	move	#>$c000,x0
	move	#$a00,r0
	jsr	<CodecXwrite		; 10,$c0
;
	move	#0,r0
	move	#$100,n0		; next reg <<8
	do	#16,_crlp1
	jsr	<CodecXread
	jsr	<PUTWORD
	move	(r0)+n0
_crlp1	nop

	jsr	<YREADS
	jsr	<PUTWORD

; ===================================================================

	movep	#>$444a,X:<<M_BCR
	nop
	bset    #M_HCIE,X:<<M_HCR    	; set HCIE
	nop
	andi	#$FD,MR			; IRQs lev 1,2 enabled
ELOOP   equ     *
	wait
	jmp     <ELOOP

; ===================================================================

	end

