
; ===================================================================

DTCBoot	ident	1,0
	page	120,60,1,1,4
	opt	cc,cex,intr,mc,md,mex
	lstcol	10,,,,

; ===================================================================
	INCLUDE		'glob56.asm'
; ===================================================================
;
; X: variables
;
Tdata		equ	0
TEMP		equ	1
IsNMI		equ	2

; ===================================================================

NULLVEC		macro
		nop
		nop
		endm

ERRVEC		macro
		jsr	>ERROR
		endm


	ORG	P:0		; bootstrap from host port

VReset	jmp	>START1		; 0000
VStkerr	ERRVEC
VTrace	ERRVEC
VSWI	ERRVEC
VIRQA	NULLVEC
VIRQB	NULLVEC
VSSIr   NULLVEC
VSSIrx  NULLVEC
VSSIt   NULLVEC
VSSItx	NULLVEC
VSCIr	NULLVEC
VSCIrx	NULLVEC
VSCIt	NULLVEC
VSCIi	NULLVEC
VSCItim	NULLVEC
VNMI	NULLVEC
VHOSTR	ERRVEC
VHOSTT	ERRVEC

VHOSTC	jsr	>PEEK
; host aux vectors @ P:0026-003E
VHC1	jsr	>POKE		; 0026
VHC2    jsr	>FILL

VHC3    NULLVEC
VHC4    NULLVEC
VHC5    NULLVEC
VHC6    NULLVEC
VHC7    NULLVEC
VHC8    NULLVEC
VHC9    NULLVEC
VHC10   NULLVEC
VHC11   NULLVEC
VHC12   NULLVEC

VILLEG  ERRVEC

; ===================================================================

; wait 64k*50n = 3.28u
WAIT1	clr	a
	rep	a1
	nop
	rts

; ===================================================================

; Get a word from Host Port into A1
;
GETWORD	jclr	#M_HRDF,X:<<M_HSR,GETWORD
	movep	X:<<M_HRX,a1
	rts

;
; Put a word from X0 into Host Port
;
PUTWORD	jclr	#M_HTDE,X:<<M_HSR,PUTWORD
	movep	x0,X:<<M_HRX
	rts

Pkpoka	jsr     <GETWORD		; get space/address <SSAAAA>
	tfr	a,b	a1,X:<TEMP
	jsr	<GETWORD		; get word count
	move	a1,n0
	move	b1,r0
	rts

;
; PEEK: put block from S:A into Host Port
;
PEEK    equ     *
	jsr     <Pkpoka
	do	n0,Endpeek
	jset	#PP_REG,X:<TEMP,PeekPE
	jset	#PP_MP,X:<TEMP,PeekPE
	jset	#PP_MXY,X:<TEMP,PeekY
PeekX   move    X:(r0)+,x0
	jmp	<Epeek0
PeekY   move    Y:(r0)+,x0
	jmp     <Epeek0
PeekPE	movem   P:(r0)+,x0
Epeek0	jsr     <PUTWORD
	nop
Endpeek	rti

;
; POKE: get block from Host Port into S:A
;
POKE    equ     *
	jsr     <Pkpoka
	do	n0,Endpoke
	jsr     <GETWORD		; get value into A1
	jset	#PP_REG,X:<TEMP,PokePE
	jset	#PP_MP,X:<TEMP,PokePE
	jset	#PP_MXY,X:<TEMP,PokeY
PokeX   move    a1,X:(r0)+
	jmp	<Epoke0
PokeY   move    a1,Y:(r0)+
	jmp	<Epoke0
PokePE	movem   a1,P:(r0)+
Epoke0	nop
Endpoke	rti

;
; FILL: fill block from Host Port into S:A
;
FILL    equ     *
	jsr     <Pkpoka
	jsr     <GETWORD		; get value into A1
	do	n0,Endfill
	jset	#PP_REG,X:<TEMP,Efill0
	jset	#PP_MP,X:<TEMP,FillPE
	jset	#PP_MXY,X:<TEMP,FillY
FillX   move    a1,X:(r0)+
	jmp	<Efill0
FillY   move    a1,Y:(r0)+
	jmp	<Efill0
FillPE	movem   a1,P:(r0)+
Efill0	nop
Endfill	rti

; ===================================================================
;
; Error processing
;
ERROR   bset    #M_HF2,X:<<M_HCR     ; set error flag (HF23 = 11)
	bset	#M_HF3,X:<<M_HCR
	ori     #3,MR           ; no IRQs
	nop
	stop
	rti

; ===================================================================
;
; PLL after reset: ckin=5MHz
;
START1  equ     *
	reset
	ori     #3,MR           ; no IRQs
	movec	#0,SP
	clr	a
	move	a,X:<IsNMI
	move	#QRAM,r7
	nop
	move	#>$1F000b,x0	; ck*12 = 60 MHz
	movep	x0,X:<<M_PCTL
	nop
	nop
	andi    #3,MR
	move	#$FFFF,m0
	movep   #0,X:<<M_HCR
	movep   #0,X:<<M_PBD
	bset    #1,X:<<M_PBC    ; (re-)enable HI, PB14 I/O
	bset	#M_HF2,X:<<M_HCR
	bclr	#M_HF3,X:<<M_HCR	; HF[3:2] = 0x08
	move	#>1,y0
	move	y0,Y:(r7)+

; @60 MHz	tc=33.3n
;		1W=50.0n
;		2W=66.6n
;		3W=83.3n
;		4W=100.0n

	movep	#$1214,X:<<M_BCR	; X=50n Y=66n P=50n Pe=100n
	move	#0,r0
	clr	a
	rep	#256
	move	a,L:(r0)+

; -------------------------------------------------------
;	Configure SCI for ()B, N81
;	System clock is 60.000 MHz
;	Ext.clock is 8.000 MHz
;
; X:SCR [13=TMIE 12=TIE 11=RIE 10=ILIE 9=TE 8=RE 7=WOMS 6=RWU 5=WAKE
;         4=SBK  2-0=WDS]
;
; ========== SCI ==================================
; internal ck= 16*BR
; in ck = 30.0 MHz
; SCLK out = BR
; SCCR value = (ck/64)/BR
; BPS = (f0/64) / ((SCP?8:1)*(CD+1))
;
; -------------------------------------------------------

	movep	#$0,X:<<M_PCDDR
	movep	#$0026,X:<<M_SCR	; EXT CK - WDS=010(8N1)
	movep	#$c002,X:<<M_SCCR	; EXT CK - Scale=/3 -> 250 kHz

;	movep	#$0002,X:<<M_SCR	; INT CK - WDS=010(8N1)
;	movep	#$001d,X:<<M_SCCR	; INT CK - Scale=/30 -> 31.25 kHz

; CRA: PSR WL(2) DC(5)  PM(8)
;       0   10   0.0000.0000.0000
	movep	#$4100,X:<<M_CRA
; CRB: RIE TIE RE TE MOD GCK SYN FSL(2) SHFD SCD(4) OF(2)
;	0   0   0  0. 0   0   1   0.0    0   00.00   00
	movep	#$0200,X:<<M_CRB

; now activate SCI/SSI
	movep	#$007,X:<<M_PCC
	move	#>2,y0
	move	y0,Y:(r7)+

; --------------------------------------------

; IRQ priorities:
;	SCI  = disabled
;	SSI  = disabled
;	HOST = level 1 (10)
;	IRQB = disabled, edge trig (100)
;	IRQA = disabled, edge trig (100)
; bit setting = 00.00|10.xx|xx.10|0.100		(x=0)

	movep	#>$0824,X:<<M_IPR

	movep	#>$1214,X:<<M_BCR
	nop
	bset	#M_HF3,X:<<M_HCR	; HF[3:2] = 0x18
	move	#>3,y0
	move	y0,Y:(r7)+

; ===================================================================
;
; peripherals on U43 use bits 8-15 !!
;
	move	#(UART1+U_SCR),r0
	move	#8,n0
	move	#>$5500,a1
	move	a1,Y:(r0)+n0
	move	a1,Y:(r0)+n0
	move	a1,Y:(r0)+n0
	move	a1,Y:(r0)+n0

	MEM_MODE0			; set memX=memY
	nop
	bset	#U_SCO7,Y:<<U_OR4	; start AD1848

	movep	#>$1218,X:<<M_BCR
	nop
	nop
_u0la	jclr	#15,Y:<<C_IAR,_u1la	; wait for init
	nop
	nop
	jmp	<_u0la
_u1la	nop
	movep	#$c00,Y:<<C_IAR
	move	#>4,y0
	move	y0,Y:(r7)+

	movep	#>$0014,X:<<M_BCR
	nop
	move	#>$56002,a1
	move	a1,X:$1000
	bclr	#M_HF2,X:<<M_HCR	; signal host, HF[3:2] = 0x10

	move	Y:$1000,x0
	jsr	<PUTWORD

	movep	#>$1214,X:<<M_BCR
	nop
	move	#UART1,r0
	move	#>$8000,x0	; >>8
	move	#>$ff,y0
	do	#40,u1loop
	move	Y:(r0)+,y1
	mpy	x0,y1,a
	and	y0,a
_u2la	jclr	#M_HTDE,X:<<M_HSR,_u2la
	movep	a1,X:<<M_HRX
u1loop	nop

	movep	#>$1218,X:<<M_BCR
	nop
	movep	#$e00,Y:<<C_IAR
	nop
	movep	#$5a00,Y:<<C_IDR
	nop
	movep	#$f00,Y:<<C_IAR
	nop
	movep	#$a500,Y:<<C_IDR
	nop
	movep	Y:<<C_IDR,x0
	jsr	<PUTWORD
	movep	#$e00,Y:<<C_IAR
	movep	Y:<<C_IDR,x0
	jsr	<PUTWORD

; ===================================================================

	movep	#>$1214,X:<<M_BCR
	nop
	bset    #M_HCIE,X:<<M_HCR    	; set HCIE
	nop
	andi	#$FD,MR			; IRQs lev 1,2 enabled
ELOOP   equ     *
	wait
	jmp     <ELOOP

; ===================================================================

	end

