
/* secondary adapter */

#include "..\dtc2.h"

#undef TWODISKS
#define CONN2
#include "conner.h"

typedef struct {
  int id;
  int fixcyl,remcyl,heads;
  int unfbytes_trk;
  int unfbytes_sect;
  int physsect_trk;
  int gap,sync;
  int nc1;
  char serialn[20];
  int type,bufsize,ECCbytes;
  char firmware[8];
  char model[40];
  int sect_int,dword,altern;
 } wident;

int wbuf[256];

/*------------------------------------------------------------------*/

int win_waitIRQ (unsigned t)
{
 int dummy;

  do delay(4);
    while ((--t)&&(inportb(WIN_STAT)&0x80));
  if (t==0) return(-1);
  return(inportb(WIN_ERR));
}

int win_waitBSY(void)
{
 int s,t;

  t=20;
  do delay(4);
    while ((--t)&&((s=inportb(WIN_STAT))&0x80));
  if (t==0) return(-1);
  return(s);
}

int win_command(int c)
{
  outportb(WIN_COMM,c);
  return(win_waitIRQ(100));
}

/*------------------------------------------------------------------*/

char *sfield(char *s,int len)
{
 int i;
 char t[80];

  for (i=0; i<len; i+=2) {
    t[i]=s[i^1]; t[i+1]=s[i];
   }
  t[len]=0;
  return(t);
}


void printbuf(int num,int *buf)
{
 wident *W = (wident *)buf;

  printf("Disk %d  id=%04x   type=%d\n",num,W->id,W->type);
  printf(" Serial=%s",sfield(W->serialn,20));
  printf("   Firmware=%s\n",sfield(W->firmware,8));
  printf(" Model= %s\n",sfield(W->model,40));
  printf(" Fixed cyls=%d  Rem.cyls=%d  Heads=%d\n",W->fixcyl,W->remcyl,
	W->heads);
  printf(" Unf.bytes/trk=%d  Unf.bytes/sect=%d  Phys.sect/trk=%d\n",
	W->unfbytes_trk,W->unfbytes_sect,W->physsect_trk);
  printf("\n");
}


int testIDEif(void)
{
 int k;

  k=inportb(WIN_CYL);
  outportb(WIN_CYL,0x55);
  if (inportb(WIN_CYL)!=0x55) return(1);
  outportb(WIN_CYL,k);
  return(0);
}


/*------------------------------------------------------------------*/

int IDEtest(void)
{
 int i;
 int *w;

  if (testIDEif()) return(1);

  outportb(WIN_DOR,2);

  outportb(WIN_SDH,0);
  if (win_command(WIN_IDENTIFY)<0) return(1);
  w=wbuf;
  for (i=0; i<256; i++) *w++ = inport(WIN_DATA);
  printf("\n--------------------------------------------------------\n");
  printbuf(0,wbuf);

#ifdef TWODISKS
  outportb(WIN_SDH,0x10);
  if (win_command(WIN_IDENTIFY)<0) return(1);
  w=wbuf;
  for (i=0; i<256; i++) *w++ = inport(WIN_DATA);
  printbuf(1,wbuf);
#endif
  printf("--------------------------------------------------------\n");

  outportb(WIN_DOR,0);
  return(0);
}

