
#include "..\dtc2.h"
#include <bios.h>

int fpgaconfPC(void);
int fpgaconfPROM(void);
int fpgatest(void);

extern int isOnCE;
int testOnCE(int log);

int IDEtest(void);

int DSPtest1(void);
int DSPtest2a(void);
int DSPtest2b(void);
int DSPtest3(void);
int DSPtest4(void);
int DSPview(void);

char dline[] = "-------------------------------------------------------------------";

unsigned long *DSPBUF;
CaptElem *CAPTBUF;
char fn[64] = BITFILE;
int resetX,resetP,lnkLoop,mon56,tstonce,tstboot,tstperi;
int ispause,tst401,iscapt,tstide,OnCEonerr;
int HWxmode;
int Cloop=0;

char far *QRAM;

extern unsigned char INV[];

/* ----------------------------------------------------------------- */


void PAUSE(void)
{
  if (ispause) {
    printf("--Paused--\n");
    getch();
   }
}


/* ----------------------------------------------------------------- */


void resetall(void)
{
  outportb(oTANALY,0);
  outportb(oTRESET,0);
  outportb(oECF2,1);
  outportb(oECF3,0);
  outportb(oTRESET,1);	/* reset T425 */
  outportb(oDRES,0);	/* reset DSP  */
  outportb(oXMODE,0);
  outportb(oDMODE,0);
  outportb(oXPROG,0);	/* inv */
  delay(100);
  outportb(oTRESET,0);
}


int memtest(void)
{
 char far *mem[3] =
  { (char far *)0xc8000000l,(char far *)0xcc000000l,(char far *)0xd0000000l };
 char far *p;
 int i,k;

  printf("Memory test");
  QRAM=NULL;

  for (k=0; k<3; k++) {
    p=mem[k];
    i=p[0x306];
    outportb(0x306,0x55);
    if (p[0x306]==0x55) {
      outportb(0x306,0xaa);
      if (p[0x306]==0xaa) break;
     }
    p[0x306]=i;
   }
  if (k>=3) return(1);
  QRAM=mem[k];
  printf(" says QRAM at %08lx ",(unsigned long)QRAM);

  printf("*");
  p=mem[k];
  for (i=0; i<1024; i++) {
    *p++=0xaa;
   }
  printf("*");
  p=mem[k];
  for (i=0; i<1024; i++) {
    if (*p!=0xaa) return(1);
    *p++=i&0xff;
   }
  printf("*");
  p=mem[k];
  for (i=0; i<1024; i++) {
    if (*p!=(i&0xff)) return(1);
    *p++=0x55;
   }
  printf("*");
  p=mem[k];
  for (i=0; i<1024; i++) {
    if (*p!=0x55) return(1);
    *p++=0;
   }
  printf("*");
  p=mem[k];
  for (i=0; i<1024; i++) {
    if (*p!=0) return(1);
   }
  return(0);
}


/* ------------------------------------------------------------------- */


int C012test(void)
{
 int i,r2,r3;

  outportb(oTRESET,1);	/* reset T425 */
  delay(100);
  outportb(oTRESET,0);
  printf("C012: %02x %02x %02x %02x\n",inportb(C012),inportb(C012+1),
	(r2=inportb(C012+2)),(r3=inportb(C012+3)));
  if ((r2!=0) || (r3!=1)) return(1);
  outportb(C012+2,2);
  if (inportb(C012+2)!=2) return(2);
  outportb(C012+2,0);
  outportb(C012+3,2);
  if (inportb(C012+3)!=3) return(3);
  outportb(C012+3,0);

  if (lnkLoop) {
    for (i=0; i<256; i++) {
      if (inportb(C012+3)&1) {
	outportb(C012+1,i);
	delay(1);
	if (inportb(C012+2)&1)
	  { if (inportb(C012)!=i) return(0); }
       }
     }
    printf("C012 loopback test OK\n");
   }

/*  outportb(oTRESET,1);	reset T425 */
  return(0);
}


/* ------------------------------------------------------------------- */


void main (int argc, char *argv[])
{
 int err,i,j,k,n;
 int testalot=0,Tcnt,Tfail;
 char *p;

  printf("DTC2 test ["__DATE__" "__TIME__"]\n");
  resetX=0; resetP=0;
  lnkLoop=0; mon56=0;
  isOnCE=0; tstonce=0; OnCEonerr=1;
  ispause=0; tst401=0; tstboot=1; tstperi=1;
  iscapt=0; tstide=0;

  DSPBUF=(unsigned long *)malloc(DBUFSIZ*sizeof(long));
  if (DSPBUF==NULL) exit(-1);
  CAPTBUF=(CaptElem *)malloc(CBUFSIZ*sizeof(CaptElem));
  if (CAPTBUF==NULL) exit(-1);

  for (i=0; i<255; i++) {
    j=i; k=0;
    for (n=0; n<7; n++) { if (j&1) k|=1; j>>=1; k<<=1; }
    INV[i]=k|j;
   }

  k=argc;
  while (--k) {
    p=argv[k];
    if ((*p=='-')||(*p=='/')) {
      switch(p[1]) {
	case 'a': tst401=(p[2]!='-'); break;
	case 'b': tstboot=(p[2]!='-'); break;
	case 'C': Cloop=(p[2]!='-'); if (Cloop) ispause=0; break;
	case 'c': iscapt=(p[2]!='-'); break;
	case 'e': OnCEonerr=(p[2]!='-'); break;
	case 'i': tstide=(p[2]!='-'); break;
	case 'o': tstonce=(p[2]!='-'); break;
	case 'p': ispause=(p[2]!='-'); break;
	case 'r': if (p[2]!='p') resetX=(p[2]!='-');
		   else resetP=(p[3]!='-');
		  break;
	case 'l': lnkLoop=(p[2]!='-'); break;
	case 'm': mon56=(p[2]!='-'); break;
	case 'T': testalot=(p[2]!='-'); break;
	case 'u': tstperi=(p[2]!='-'); break;
	default:  break;
      }
    }
  }

  resetall();

  if (!DTC2present(&QRAM)) {
    printf("DTC2 not found\n");
    exit(1);
   }

  k = inportb(iXINIT)&1;
  printf("FPGA INIT/ERR = %c\n",(k+'0'));
  k = inportb(iXDONE)&1;
  printf("FPGA DONE     = %c\n",(k+'0'));
  k = inportb(iXMODE)&1;
  printf("FPGA MODE     = %c0%c\n",(k+'0'),(k+'0'));
  k = !(inportb(iLOCAL)&1);
  printf("LOCAL MODE    = %c\n",(k+'0'));

  err=0;
  k = inportb(iXDONE)&1;
  if (!k) printf("FPGA not configured\n");
    else printf("FPGA already configured\n");
  if (resetX||resetP) printf("reconfiguring FPGA\n");

  if ((!k) || resetX || resetP) {
    if (resetP) {
      outportb(oXMODE,HWxmode);
      err=fpgaconfPROM();
     }
    else {
/* reset from PC - put in mode 1 */
      outportb(oXMODE,!HWxmode);
      err=fpgaconfPC();
     }
   }

  if (!err) {
/* test echo of CTRL0 bit */
    outportb(FPGA,1);
    if ((inportb(FPGA+1)&0x20)==0) err=1;
    outportb(FPGA,0);
    if ((inportb(FPGA+1)&0x20)!=0) err=1;
   }
  if (err) {
    printf("error in FPGA config\n"); exit(1);
   }
  outportb(oXMODE,!HWxmode);	/* set FPGA mode always to 1 */

  if (memtest()) {
    printf("Error in memory test\n");
   }
  else printf("Memory test OK\n");

  if (err=C012test()) {
    printf("Error %d in C012 test\n",err);
   }
  else printf("C012 test OK\n");

  PAUSE();

  if (tstide) {
    if (IDEtest()) {
      printf("Error in IDE test\n"); goto quit;
     }
    else printf("IDE seems ok\n");
   }

  PAUSE();

rept0:

  fpgatest();

  PAUSE();

  if (tstboot) {
    Tcnt=(testalot? 40:1); Tfail=0;
    printf("TEST 1 ");
    while (Tcnt--) {
      if (DSPtest1()) {
	printf("\nError in DSP test 1\n"); Tfail++; break;
       }
      printf("*");
     }
    if (!Tfail) printf("\nDSP test 1 OK\n");
    PAUSE();
   }

  Tcnt=(testalot? 40:1); Tfail=0;
  printf("TEST 2 ");
  while (Tcnt--) {
    if (DSPtest2a()) {
      printf("Error in DSP test 2A\n"); Tfail++; break;
     }
    printf("*");
    if (DSPtest2b()) {
      printf("Error in DSP test 2B\n"); Tfail++; break;
     }
    printf("*");
   }
  if (!Tfail) printf("\nDSP test 2 OK\n");

  if (tstperi) {
    Tcnt=(testalot? 40:1); Tfail=0;
    printf("TEST 3 ");
    while (Tcnt--) {
      if (DSPtest3()) {
	printf("Error in DSP test 3\n"); Tfail++; break;
       }
      printf("*");
     }
    if (!Tfail) printf("\nDSP test 3 OK\n");
   }

  if (tst401) {
    if (err=DSPtest4()) {
      printf("Error %d in DSP test 4: ",err);
      switch (err) {
	case 2: printf("bad data\n"); break;
	case 3: printf("no ack\n"); break;
	default: printf("timeout\n"); break;
       }
     }
    else printf("DSP test 4 OK\n");
   }

  if (tstonce) {
    if (err=testOnCE(0)) {
      printf("Error %d in DSP OnCE test\n",err);
     }
    else printf("DSP OnCE test OK\n");
   }

  if (Cloop) {
    if (!bioskey(1)) { delay(1000); goto rept0; }
    if (getch()=='o') { testOnCE(1); goto rept0; }
   }

  if (mon56) DSPview();

quit:
  outportb(oDRES,0);	/* reset DSP  */

  exit(0);
}

