
; ===================================================================

M4test 	ident	1,0
	page	120,60,1,1,4
	opt	cc,cex,intr,mc,md,mex
	lstcol	10,,,,

; ===================================================================
	INCLUDE		'..\glob56.asm'
; ===================================================================
;
; X: variables
;
Tdata		equ	0
TEMP		equ	1
IsNMI		equ	2
;
; Y: variables
;
Q1D		equ	8
Q1CD		equ     9
Q2D		equ    10
Q2CD		equ    11
Q3D		equ    12
Q3CD		equ    13
Q4D		equ    14
Q4CD		equ    15

; ===================================================================

NULLVEC		macro
		nop
		nop
		endm

ERRVEC		macro
		jsr	>ERROR
		endm

	ORG	P:0		; bootstrap from host port

VReset	jmp	>START1		; 0000
VStkerr	ERRVEC
VTrace	ERRVEC
VSWI	ERRVEC
VIRQA	ERRVEC
VIRQB	ERRVEC
VSSIr   NULLVEC
VSSIrx  NULLVEC
VSSIt   NULLVEC
VSSItx	NULLVEC
VSCIr	NULLVEC
VSCIrx	NULLVEC
VSCIt	NULLVEC
VSCIi	NULLVEC
VSCItim	NULLVEC
VNMI	ERRVEC
VHOSTR	NULLVEC
VHOSTT	NULLVEC

VHOSTC	jsr	>PEEK
; host aux vectors @ P:0026-003E
VHC1	jsr	>POKE		; 0026
VHC2    jsr	>FILL

VHC3    NULLVEC
VHC4    NULLVEC
VHC5    NULLVEC
VHC6    NULLVEC
VHC7    NULLVEC
VHC8    NULLVEC
VHC9    NULLVEC
VHC10   NULLVEC
VHC11   NULLVEC
VHC12   NULLVEC

VILLEG  ERRVEC

; ===================================================================

; wait 64k*50n = 3.28u
WAIT1	clr	a
	rep	a1
	nop
	rts

; ===================================================================

; Get a word from Host Port into A1
;
GETWORD	jclr	#M_HRDF,X:<<M_HSR,GETWORD
	movep	X:<<M_HRX,a1
	rts

;
; Put a word from X0 into Host Port
;
PUTWORD	jclr	#M_HTDE,X:<<M_HSR,PUTWORD
	movep	x0,X:<<M_HTX
	rts

Pkpoka	jsr     <GETWORD		; get space/address <SSAAAA>
	tfr	a,b	a1,X:<TEMP
	jsr	<GETWORD		; get word count
	move	a1,n0
	move	b1,r0
	rts

;
; PEEK: put block from S:A into Host Port
;
PEEK    equ     *
	jsr     <Pkpoka
	do	n0,Endpeek
	jset	#PP_REG,X:<TEMP,PeekPE
	jset	#PP_MP,X:<TEMP,PeekPE
	jset	#PP_MXY,X:<TEMP,PeekY
PeekX   move    X:(r0)+,x0
	jmp	<Epeek0
PeekY   move    Y:(r0)+,x0
	jmp     <Epeek0
PeekPE	movem   P:(r0)+,x0
Epeek0	jsr     <PUTWORD
	nop
Endpeek	rti

;
; POKE: get block from Host Port into S:A
;
POKE    equ     *
	jsr     <Pkpoka
	do	n0,Endpoke
	jsr     <GETWORD		; get value into A1
	jset	#PP_REG,X:<TEMP,PokePE
	jset	#PP_MP,X:<TEMP,PokePE
	jset	#PP_MXY,X:<TEMP,PokeY
PokeX   move    a1,X:(r0)+
	jmp	<Epoke0
PokeY   move    a1,Y:(r0)+
	jmp	<Epoke0
PokePE	movem   a1,P:(r0)+
Epoke0	nop
Endpoke	rti

;
; FILL: fill block from Host Port into S:A
;
FILL    equ     *
	jsr     <Pkpoka
	jsr     <GETWORD		; get value into A1
	do	n0,Endfill
	jset	#PP_REG,X:<TEMP,Efill0
	jset	#PP_MP,X:<TEMP,FillPE
	jset	#PP_MXY,X:<TEMP,FillY
FillX   move    a1,X:(r0)+
	jmp	<Efill0
FillY   move    a1,Y:(r0)+
	jmp	<Efill0
FillPE	movem   a1,P:(r0)+
Efill0	nop
Endfill	rti

; ===================================================================
;
; Error processing
;
ERROR   equ	*
;	bset    #M_HF2,X:<<M_HCR     ; set error flag (HF23 = 11)
;	bset	#M_HF3,X:<<M_HCR
;	ori     #3,MR           ; no IRQs
;	nop
	dc	$200		; debug
	stop
	rti

; ===================================================================
;
; PLL after reset: ckin=5MHz
;
START1  equ     *
	move	#>$1F000b,x0	; ck*12 = 60 MHz
	movep	x0,X:<<M_PCTL
	nop
	nop
	movep   #0,X:<<M_HCR
	movep   #0,X:<<M_PBD
	bset    #1,X:<<M_PBC    ; (re-)enable HI, PB14 I/O
	ori     #3,MR           ; no IRQs
	movec	#0,SP
	andi    #3,MR
	move	#$FFFF,m0

; @60 MHz	tc=33.3n
;		1W=50.0n
;		2W=66.6n
;		3W=83.3n
;		4W=100.0n

	movep	#$1114,X:<<M_BCR	; X=50n Y=66n P=50n Pe=100n
	move	#0,r0
	clr	a
	rep	#256
	move	a,L:(r0)+

; -------------------------------------------------------
;	Configure SCI for ()B, N81
;	System clock is 60.000 MHz
;	Ext.clock is 8.000 MHz
;
; X:SCR [13=TMIE 12=TIE 11=RIE 10=ILIE 9=TE 8=RE 7=WOMS 6=RWU 5=WAKE
;         4=SBK  2-0=WDS]
;
; ========== SCI ==================================
; internal ck= 16*BR
; in ck = 30.0 MHz
; SCLK out = BR
; SCCR value = (ck/64)/BR
; BPS = (f0/64) / ((SCP?8:1)*(CD+1))
;
; -------------------------------------------------------

	movep	#$0,X:<<M_PCDDR
	movep	#$0026,X:<<M_SCR	; EXT CK - WDS=010(8N1)
	movep	#$c002,X:<<M_SCCR	; EXT CK - Scale=/3 -> 250 kHz

;	movep	#$0002,X:<<M_SCR	; INT CK - WDS=010(8N1)
;	movep	#$001d,X:<<M_SCCR	; INT CK - Scale=/30 -> 31.25 kHz

; CRA: PSR WL(2) DC(5)  PM(8)
;       0   10   0.0000.0000.0000
	movep	#$4100,X:<<M_CRA
; CRB: RIE TIE RE TE MOD GCK SYN FSL(2) SHFD SCD(4) OF(2)
;	0   0   0  0. 0   0   1   0.0    0   00.00   00
	movep	#$0200,X:<<M_CRB

; now activate SCI/SSI
	movep	#$007,X:<<M_PCC

; --------------------------------------------

; IRQ priorities:
;	SCI  = disabled
;	SSI  = disabled
;	HOST = level 1 (10)
;	IRQB = disabled, edge trig (100)
;	IRQA = disabled, edge trig (100)
; bit setting = 00.00|10.xx|xx.10|0.100		(x=0)

	movep	#>$0824,X:<<M_IPR

	movep	#>$1114,X:<<M_BCR

; ===================================================================
;
; peripherals on U43 use bits 8-15 !!
;
	MEM_MODE0
	nop
	movep	#>$4844,X:<<M_BCR
	nop
	move	#>$401401,x0
	jsr	<PUTWORD

	move	#F_TF,r0
	move	#F_AF,r1
	move	#F_RF,r2
	move	#2,n4			; increment
	move	#2,n5

	move	Y:(r0),x0
	jsr	<PUTWORD
	move	Y:(r2),x0
	jsr	<PUTWORD
	move	Y:(r1),x0
	jsr	<PUTWORD

	move	#>$ff,x1		; mask
	move	#>$fe,y1		; ack
	nop
	bset    #M_HCIE,X:<<M_HCR    	; set HCIE
	nop
	andi	#$FD,MR			; IRQs lev 1,2 enabled

MLOOP	move	#(QR401+6),r4		; data reg
	move	#(QR401+7),r5		; ctrl reg
	move	#(F_CW+3),r3		; e003(W)
	move	#(F_CR+3),r6		; e007(W)
	move	Y:(r0),b1		; load transmit flags into b20-23
	lsl	b			; TF[3] to carry
	jcc	<next2
;--- chan#3 ---------------------------------
	btst	#23,Y:(r1)		; last addr 0=DATA 1=CTRL
	jcs	<xft3c
xft3d	move	Y:(r4),a		; get and save data
	and	x1,a
	move	a1,Y:<Q4D
	not	a
	move	a1,Y:(r4)		; pass notData back
	jmp	<xft2
xft3c   move	Y:(r5),a
	and	x1,a
	move	a1,Y:<Q4CD
	move	y1,Y:(r4)		; pass ACK back
xft2	move	a2,Y:(r3)		; clear xmit flag
	move	a2,Y:(r6)		; clear recv flag
;--------------------------------------------

next2	move	(r4)-n4
	move	(r5)-n5
	move	(r3)-
	move	(r6)-
	lsl	b			; TF[2] to carry
	jcc	<next1
;--- chan#2 ---------------------------------
	btst	#22,Y:(r1)		; last addr 0=DATA 1=CTRL
	jcs	<xft2c
xft2d	move	Y:(r4),a		; get and save data
	and	x1,a
	move	a1,Y:<Q3D
	not	a
	move	a1,Y:(r4)		; pass notData back
	jmp	<xft1
xft2c   move	Y:(r5),a
	and	x1,a
	move	a1,Y:<Q3CD
	move	y1,Y:(r4)		; pass ACK back
xft1	move	a2,Y:(r3)		; clear xmit flag
	move	a2,Y:(r6)		; clear recv flag
;--------------------------------------------

next1	move	(r4)-n4
	move	(r5)-n5
	move	(r3)-
	move	(r6)-
	lsl	b			; TF[1] to carry
	jcc	<next0
;--- chan#1 ---------------------------------
	btst	#21,Y:(r1)		; last addr 0=DATA 1=CTRL
	jcs	<xft1c
xft1d	move	Y:(r4),a		; get and save data
	and	x1,a
	move	a1,Y:<Q2D
	not	a
	move	a1,Y:(r4)		; pass notData back
	jmp	<xft0
xft1c   move	Y:(r5),a
	and	x1,a
	move	a1,Y:<Q2CD
	move	y1,Y:(r4)		; pass ACK back
xft0	move	a2,Y:(r3)		; clear xmit flag
	move	a2,Y:(r6)		; clear recv flag
;--------------------------------------------

next0	move	(r4)-n4
	move	(r5)-n5
	move	(r3)-
	move	(r6)-
	lsl	b			; TF[0] to carry
	jcc	<MLOOP
;--- chan#0 ---------------------------------
	btst	#20,Y:(r1)		; last addr 0=DATA 1=CTRL
	jcs	<xft0c
xft0d	move	Y:(r4),a		; get and save data
	and	x1,a
	move	a1,Y:<Q1D
	not	a
	move	a1,Y:(r4)		; pass notData back
	jmp	<xfte
xft0c   move	Y:(r5),a
	and	x1,a
	move	a1,Y:<Q1CD
	move	y1,Y:(r4)		; pass ACK back
xfte	move	a2,Y:(r3)		; clear xmit flag
	move	a2,Y:(r6)		; clear recv flag
;--------------------------------------------
	jmp	<MLOOP

; ===================================================================

	end

