
; ===================================================================

DTCMtst	ident	1,0
	page	120,60,1,1,4
	opt	cc,cex,intr,mc,md,mex
	lstcol	10,,,,

; ===================================================================
	INCLUDE		'..\glob56.asm'
; ===================================================================

MFAST		equ	$0014
MNORM		equ	$1114
;
; X: variables
;
Tdata		equ	0
TEMP		equ	1
TMP2		equ	2

; ===================================================================

NULLVEC		macro
		nop
		nop
		endm

ERRVEC		macro
		jsr	>ERROR
		endm


	ORG	P:0		; bootstrap from host port

VReset	jmp	>START1		; 0000
VStkerr	ERRVEC
VTrace	ERRVEC
VSWI	ERRVEC
VIRQA	NULLVEC
VIRQB	NULLVEC
VSSIr   NULLVEC
VSSIrx  NULLVEC
VSSIt   NULLVEC
VSSItx	NULLVEC
VSCIr	NULLVEC
VSCIrx	NULLVEC
VSCIt	NULLVEC
VSCIi	NULLVEC
VSCItim	NULLVEC
VNMI	NULLVEC
VHOSTR	ERRVEC
VHOSTT	ERRVEC

VHOSTC	jsr	>PEEK
; host aux vectors @ P:0026-003E
VHC1	jsr	>POKE		; 0026
VHC2    jsr	>FILL

VHC3    NULLVEC
VHC4    NULLVEC
VHC5    NULLVEC
VHC6    NULLVEC
VHC7    NULLVEC
VHC8    NULLVEC
VHC9    NULLVEC
VHC10   NULLVEC
VHC11   NULLVEC
VHC12   NULLVEC

VILLEG  jsr	>ILLOP

; ===================================================================

; wait 64k*50n = 3.28u
WAIT1	clr	a
	rep	a1
	nop
	rts

; ===================================================================

; Get a word from Host Port into A1
;
GETWORD	jclr	#M_HRDF,X:<<M_HSR,GETWORD
	movep	X:<<M_HRX,a1
	rts

;
; Put a word from X0 into Host Port
;
PUTWORD	jclr	#M_HTDE,X:<<M_HSR,PUTWORD
	movep	x0,X:<<M_HTX
	rts

Pkpoka	jsr     <GETWORD		; get space/address <SSAAAA>
	tfr	a,b	a1,X:<TEMP
	jsr	<GETWORD		; get word count
	move	a1,n0
	move	b1,r0
	rts

;
; PEEK: put block from S:A into Host Port
;
PEEK    equ     *
	jsr     <Pkpoka
	do	n0,Endpeek
	jset	#PP_REG,X:<TEMP,PeekPE
	jset	#PP_MP,X:<TEMP,PeekPE
	jset	#PP_MXY,X:<TEMP,PeekY
PeekX   move    X:(r0)+,x0
	jmp	<Epeek0
PeekY   move    Y:(r0)+,x0
	jmp     <Epeek0
PeekPE	movem   P:(r0)+,x0
Epeek0	jsr     <PUTWORD
	nop
Endpeek	rti

;
; POKE: get block from Host Port into S:A
;
POKE    equ     *
	jsr     <Pkpoka
	do	n0,Endpoke
	jsr     <GETWORD		; get value into A1
	jset	#PP_REG,X:<TEMP,PokePE
	jset	#PP_MP,X:<TEMP,PokePE
	jset	#PP_MXY,X:<TEMP,PokeY
PokeX   move    a1,X:(r0)+
	jmp	<Epoke0
PokeY   move    a1,Y:(r0)+
	jmp	<Epoke0
PokePE	movem   a1,P:(r0)+
Epoke0	nop
Endpoke	rti

;
; FILL: fill block from Host Port into S:A
;
FILL    equ     *
	jsr     <Pkpoka
	jsr     <GETWORD		; get value into A1
	do	n0,Endfill
	jset	#PP_REG,X:<TEMP,Efill0
	jset	#PP_MP,X:<TEMP,FillPE
	jset	#PP_MXY,X:<TEMP,FillY
FillX   move    a1,X:(r0)+
	jmp	<Efill0
FillY   move    a1,Y:(r0)+
	jmp	<Efill0
FillPE	movem   a1,P:(r0)+
Efill0	nop
Endfill	rti

; ===================================================================
;
; Error processing
;
ILLOP	equ	*
ERROR   equ	*
;	bset    #M_HF2,X:<<M_HCR     ; set error flag (HF23 = 11)
;	bset	#M_HF3,X:<<M_HCR
	ori     #3,MR           ; no IRQs
	nop
	debug
	jmp	*

; ===================================================================
;
FIFOCMD	equ	*
	movep	#$200,Y:<<U_OR1
	move	#>$aa,x0
	move	x0,P:(FLASH+$1555)
	movep	#$300,Y:<<U_OR1
	move	#>$55,x0
	move	x0,P:(FLASH+$2AAA)
	movep	#$200,Y:<<U_OR1
	nop
	move	a1,P:(FLASH+$1555)
	rts
;
; Flash addresses
;			INVERTED OUT!	<<8!
;	00000-03FFF	SC0=1 SC1=1	OR1=3	P:$C000-$FFFF
;	04000-07FFF	SC0=0 SC1=1	OR1=2	P:$C000-$FFFF
;	08000-0BFFF	SC0=1 SC1=0	OR1=1	P:$C000-$FFFF
;	0C000-0FFFF	SC0=0 SC1=0	OR1=0	P:$C000-$FFFF
;	10000-13FFF	SC0=1 SC1=1	OR1=3	X:$C000-$FFFF
;	14000-17FFF	SC0=0 SC1=1	OR1=2	X:$C000-$FFFF
;	18000-1BFFF	SC0=1 SC1=0	OR1=1	X:$C000-$FFFF
;	1C000-1FFFF	SC0=0 SC1=0	OR1=0	X:$C000-$FFFF
;
AUTOSEL	equ	*
	movep	#>$1144,X:<<M_BCR	; 4 WS for P:
	move	#>$90,a1
	jsr	<FIFOCMD
	move	P:$C000,x0		; manifacture code 01 [7 bit]
	move	P:$C001,x1		; device code 20      [7 bit]
	move	P:$C002,a1		; protected sectors
	rts
;
READRST	equ	*
	movep	#>$1144,X:<<M_BCR	; 4 WS for P:
	move	#>$F0,a1
	jsr	<FIFOCMD
	move	P:$C000,a1
	rts
;
; ===================================================================
;
; PLL after reset: ckin=5MHz
;
START1  equ     *
	move	#>$1F000c,x0	; ck*12 = 60 MHz
	movep	x0,X:<<M_PCTL
	nop
	nop
	movep   #0,X:<<M_HCR
	movep   #0,X:<<M_PBD
	bset    #1,X:<<M_PBC    ; (re-)enable HI, PB14 I/O
	ori     #3,MR           ; no IRQs
	movec	#0,SP
	andi    #3,MR
	move	#$FFFF,m0

; @60 MHz	tc=33.3n
;		1W=50.0n
;		2W=66.6n
;		3W=83.3n
;		4W=100.0n

	movep	#$1214,X:<<M_BCR	; X=50n Y=66n P=50n Pe=100n
	move	#0,r0
	clr	a
	rep	#256
	move	a,L:(r0)+

; -------------------------------------------------------
;	Configure SCI for ()B, N81
;	System clock is 60.000 MHz
;	Ext.clock is 8.000 MHz
;
; X:SCR [13=TMIE 12=TIE 11=RIE 10=ILIE 9=TE 8=RE 7=WOMS 6=RWU 5=WAKE
;         4=SBK  2-0=WDS]
;
; ========== SCI ==================================
; internal ck= 16*BR
; in ck = 30.0 MHz
; SCLK out = BR
; SCCR value = (ck/64)/BR
; BPS = (f0/64) / ((SCP?8:1)*(CD+1))
;
; -------------------------------------------------------

	movep	#$0,X:<<M_PCDDR
	movep	#$0026,X:<<M_SCR	; EXT CK - WDS=010(8N1)
	movep	#$c002,X:<<M_SCCR	; EXT CK - Scale=/3 -> 250 kHz

;	movep	#$0002,X:<<M_SCR	; INT CK - WDS=010(8N1)
;	movep	#$001d,X:<<M_SCCR	; INT CK - Scale=/30 -> 31.25 kHz

; CRA: PSR WL(2) DC(5)  PM(8)
;       0   10   0.0000.0000.0000
	movep	#$4100,X:<<M_CRA
; CRB: RIE TIE RE TE MOD GCK SYN FSL(2) SHFD SCD(4) OF(2)
;	0   0   0  0. 0   0   1   0.0    0   00.00   00
	movep	#$0200,X:<<M_CRB

; now activate SCI/SSI
	movep	#$007,X:<<M_PCC

; --------------------------------------------

; IRQ priorities:
;	SCI  = disabled
;	SSI  = disabled
;	HOST = level 1 (10)
;	IRQB = disabled, edge trig (100)
;	IRQA = disabled, edge trig (100)
; bit setting = 00.00|10.xx|xx.10|0.100		(x=0)

	movep	#>$0824,X:<<M_IPR
	jmp	>GOTEST

; ===================================================================

T_smem	equ	$300
T_emem	equ	$c000
T_len	equ	(T_emem-T_smem)
T_hlen	equ	(T_len/2)
;
TST1	equ	*
; test mode #0, 1 wait
	MEM_MODE0			; set memX=memY
	move	#0,x1
	move	#T_smem,r0
	move	#$55aa55,x0
	move	#$aa55aa,y0
	move	#T_len,r4
	move	r0,r1
	rep	r4
	move	x0,P:(r0)+		; P->55aa55
	move	r1,r0
	do	r4,_mtlp1
	move	Y:(r0),a		; a=55aa55?
	eor	y0,a
	not	a
	jne	<_merr1
	move	y0,Y:(r0)		; Y(r0)=aa55aa
	move	X:(r0),a		; a=aa55aa?
	eor	x0,a
	not	a
	jeq	<_mter1
_merr1	move	a1,y1
	or	y1,b	r0,r1
_mter1	move	x1,X:(r0)+
_mtlp1	nop
	rts

TST2	equ	*
; test mode #0, 0 wait
	MEM_MODE0			; set memX=memY
	move	#0,x1
	move	#T_smem,r0
	move	#$aa55aa,x0
	move	#$55aa55,y0
	move	#T_len,r4
	move	r0,r1
	rep	r4
	move	x0,P:(r0)+
	move	r1,r0
	do	r4,_mtlp2
	move	Y:(r0),a
	eor	y0,a
	not	a
	jne	<_merr2
	move	y0,Y:(r0)
	move	X:(r0),a
	eor	x0,a
	not	a
	jeq	<_mter2
_merr2	move	a1,y1
	or	y1,b	r0,r1
_mter2	move	x1,X:(r0)+
_mtlp2	nop
	rts

TST3	equ	*
; test Y memory mode #1, 0 wait
	MEM_MODE1			; set memX!=memY
	move	#0,y1
	move	#T_smem,r0
	move	#$55aa55,x0
	move	#$aa55aa,y0
	move	#T_len,r4
	move	r0,r1
	do	r4,_mtlp3
	move	x0,Y:(r0)
	move	Y:(r0),a
	eor	y0,a	y1,Y:(r0)+
	not	a
	jeq	<_mter3
	move	a1,x1
	or	x1,b	r0,r1
_mter3	nop
_mtlp3	nop
	rts

TST4	equ	*
; test mode #0, 0 wait
	MEM_MODE0			; set memX=memY
	nop
	move	#T_smem,r0
	move	#(T_emem-1),r4
	move	#T_hlen,r1
	nop
	do	r1,_mtlp4
	move	r0,X:(r0)+
	move	r4,X:(r4)-
_mtlp4	nop
	move	#T_smem,r0
	move	#T_len,r4
	move	r0,r1
	do	r4,_mtlp5
	move	r0,x0
	move	X:(r0)+,a
	eor	x0,a
	jeq	<_mter5
	move	a1,x1
	or	x1,b	r0,r1
_mter5	nop
_mtlp5	nop
	rts

TST5	equ	*
; test mode #0, 0 wait
	move	b1,X:<TMP2
	MEM_MODE0			; set memX=memY
	nop
	move	#T_smem,r0
	move	#(T_emem-1),r4
	move	#T_hlen,r1
	nop
	do	r1,_mtlp5
	move	r0,a1
	not	a	r4,b1
	not	b	a1,Y:(r0)+
	move	b1,Y:(r4)-
_mtlp5	nop
	move	X:<TMP2,b1
	move	#T_smem,r0
	move	#T_len,r4
	move	r0,r1
	do	r4,_mtlp6
	move	r0,x0
	move	Y:(r0)+,a1
	not	a
	eor	x0,a
	jeq	<_mter6
	move	a1,x1
	or	x1,b	r0,r1
_mter6	nop
_mtlp6	nop
	rts

;
; MODE 0
; X:100..BFFF = Y:100..BFFF = P:200..BFFF
;
; MODE 1
; X:100..BFFF = P:200..BFFF   Y:100..BFFF
;
; peripherals on U43 use bits 8-15 !!
;
GOTEST	equ	*
	movep	#>MFAST,X:<<M_BCR
	clr	b
	jsr	<TST2
	jsr	<TST3
	jsr	<TST4
	jsr	<TST5
	jsr	<TST1
;	bclr	#M_HF2,X:<<M_HCR	; signal host
	move	b1,x0
	jsr	<PUTWORD
	move	r1,x0
	jsr	<PUTWORD
;
	movep	#>MNORM,X:<<M_BCR
	clr	b
	jsr	<TST3
	jsr	<TST4
	jsr	<TST5
	jsr	<TST1
	jsr	<TST2
	move	b1,x0
	jsr	<PUTWORD
	move	r1,x0
	jsr	<PUTWORD
;
	movep	#>MFAST,X:<<M_BCR
	clr	b
	jsr	<TST4
	jsr	<TST5
	jsr	<TST1
	jsr	<TST2
	jsr	<TST3
	move	b1,x0
	jsr	<PUTWORD
	move	r1,x0
	jsr	<PUTWORD
;
	movep	#>MNORM,X:<<M_BCR
	clr	b
	jsr	<TST5
	jsr	<TST1
	jsr	<TST2
	jsr	<TST3
	jsr	<TST4
	move	b1,x0
	jsr	<PUTWORD
	move	r1,x0
	jsr	<PUTWORD

	move	#0,r0
	move	r0,r1
	move	r0,r2
	move	r0,r4

	jsr	<AUTOSEL		; select FIFO, get x0-x1-a1
	jsr	<PUTWORD
	move	x1,x0
	jsr	<PUTWORD
	move	a1,x0
	jsr	<PUTWORD
	jsr	<READRST

; ===================================================================

	movep	#>$4448,X:<<M_BCR
	nop
	bset    #M_HCIE,X:<<M_HCR    	; set HCIE
	nop
	andi	#$FD,MR			; IRQs lev 1,2 enabled
ELOOP   equ     *
	wait
	jmp     <ELOOP

; ===================================================================

	end

