
#include "..\dtc2.h"

#undef  ONCETRC
#define ONCEV2

extern char dline[];
extern unsigned long *DSPBUF;
int isOnCE;

static int Olog=0;
static FILE *flog;
static char Sbuf[512];

int in_debug_mode=0;
int bootmode=0,Resetp=0,LoadFile=0,StopMon=0;
char lodfile[256];
unsigned lowestP;

OnCEregs Oregs;
DSPregs  Dregs;

ulong bk_hi=0,bk_lo=0,bk_cnt=0;
int   isbk=0;

/* ----------------------------------------------------------------- */

static void Lprint(void)
{
  if (Olog) fputs(Sbuf,flog);
  printf("%s",Sbuf);
}

/* ----------------------------------------------------------------- */


int OnCEwr8(unsigned int n)
{
 unsigned t;

  outportb(OnCEdat,n);
  outportb(OnCEclk,0);		/* 8 auto cycles */
  while ((inportb(OnCEstat)&8)==0);
  t=20000;
  while (((inportb(OnCEstat)&4)==0)&&(--t));
  return(t==0);
}


int OnCEwr24(unsigned long v,int ack)
{
 unsigned t;

  outportb(OnCEdat,(v>>16));
  outportb(OnCEclk,0);		/* 8 auto cycles */
  while ((inportb(OnCEstat)&8)==0);
  outportb(OnCEdat,(v>>8));
  outportb(OnCEclk,0);		/* 8 auto cycles */
  while ((inportb(OnCEstat)&8)==0);
  outportb(OnCEdat,v);
  outportb(OnCEclk,0);		/* 8 auto cycles */
  while ((inportb(OnCEstat)&8)==0);
  if (!ack) return(0);
  t=20000;
  while (((inportb(OnCEstat)&4)==0)&&(--t));
  return(t==0);
}


int OnCErd8(void)
{
 unsigned t,v;

  outportb(OnCEdat,0);
  outportb(OnCEclk,0);		/* 8 auto cycles */
  while ((inportb(OnCEstat)&8)==0);
  v=inportb(OnCEdat);
  t=20000;
  while (((inportb(OnCEstat)&4)==0)&&(--t)); if (t==0) return(-1);
  return(v&0xff);
}


long OnCErd24(int ack)
{
 unsigned t;
 long v;

  outportb(OnCEdat,0);
  outportb(OnCEclk,0);		/* 8 auto cycles */
  while ((inportb(OnCEstat)&8)==0);
  v=inportb(OnCEdat);
  outportb(OnCEclk,0);		/* 8 auto cycles */
  while ((inportb(OnCEstat)&8)==0);
  v=(v<<8)|inportb(OnCEdat);
  outportb(OnCEclk,0);		/* 8 auto cycles */
  while ((inportb(OnCEstat)&8)==0);
  v=(v<<8)|inportb(OnCEdat);
  if (ack) {
    t=20000;
    while (((inportb(OnCEstat)&4)==0)&&(--t)); if (t==0) return(-1l);
   }
  return(v&0xffffff);
}


long ONCErdat(int reg,int ack)
{
 long v;

  if (OnCEwr8((reg&0x1f)|O_read|O_nogo|O_noex)) return(-1l);
  return(OnCErd24(ack));
}


int ONCEwdat(int reg,long v,int ack)
{
  if (OnCEwr8(reg)) return(1);
  return(OnCEwr24(v,ack));
}


long ONCErreg(int r)	/* r=register MASK */
{
  if (ONCEwdat(O_OPDBR|O_write|O_go|O_noex,O_GmovR|r,1)) return(-1l);
  return(ONCErdat(O_OGDBR,1));
}


/* ------------------------------------------------------------------- */


static int near getmblock(int space,long a,int n)
{
 int rd=0;
 long r0;
 unsigned long *p = DSPBUF;

  if (n==0) return(0);
  if (n>511) n=512;
  ONCEwdat(O_OPDBR|O_write|O_go|O_noex,O_GmovR|0x1000,1); /* move r0,X:OGDB */
  r0=ONCErdat(O_OGDBR,0);
  ONCEwdat(O_OPDBR|O_write|O_nogo|O_noex,O_moviR0,1);	  /* move #xxxx,r0 */
  ONCEwdat(O_OPDBR|O_write|O_go|O_noex,a,1);		  /* move #xxxx,r0 */
  ONCEwdat(O_OPDBR|O_write|O_go|O_noex,O_movR0p+space,1); /* move S:(r0)+,X:OGDB */
  *p++=ONCErdat(O_OGDBR,0); n--; rd++;
  while (n--) {
    OnCEwr8(O_noreg|O_go|O_noex);
    *p++=ONCErdat(O_OGDBR,0); rd++;
   }
  ONCEwdat(O_OPDBR|O_write|O_nogo|O_noex,O_moviR0,1);  	  /* move #xxxx,r0 */
  ONCEwdat(O_OPDBR|O_write|O_go|O_noex,r0,1);		  /* move #xxxx,r0 */
  return(rd);
}


static void near showallreg(void)
{
 int i,k;

  sprintf(Sbuf,"%s\n",dline); Lprint();
  sprintf(Sbuf,"   X1:X0=   %06lx:%06lx\t",ONCErreg(0x500),ONCErreg(0x400));
  Lprint();
  sprintf(Sbuf,"   Y1:Y0=   %06lx:%06lx\n",ONCErreg(0x700),ONCErreg(0x600));
  Lprint();
  sprintf(Sbuf,"A2:A1:A0=%02lx:%06lx:%06lx\t",ONCErreg(0xa00)&0xff,
	  ONCErreg(0xc00),ONCErreg(0x800)); Lprint();
  sprintf(Sbuf,"B2:B1:B0=%02lx:%06lx:%06lx\n",ONCErreg(0xb00)&0xff,
	  ONCErreg(0xd00),ONCErreg(0x900)); Lprint();
  k=0x1000;
  for (i=0; i<4; i++) {
    sprintf(Sbuf,"   R%d=%04lx  N%d=%04lx  M%d=%04lx\t",i,ONCErreg(k)&0xffff,
	  i,ONCErreg(k+0x800)&0xffff,i,ONCErreg(k+0x1000)&0xffff);
    Lprint();
    sprintf(Sbuf,"   R%d=%04lx  N%d=%04lx  M%d=%04lx\n",i+4,ONCErreg(k+0x400)&0xffff,
	  i+4,ONCErreg(k+0xc00)&0xffff,i+4,ONCErreg(k+0x1400)&0xffff);
    Lprint();
    k+=0x100;
   }
  sprintf(Sbuf,"SR=%04lx  OMR=%04lx  ",ONCErreg(0x3900),ONCErreg(0x3a00));
  Lprint();
  sprintf(Sbuf,"SP=%04lx   LA=%04lx  ",ONCErreg(0x3b00),ONCErreg(0x3e00));
  Lprint();
  sprintf(Sbuf,"LC=%04lx\n",ONCErreg(0x3f00));
  Lprint();
  sprintf(Sbuf,"%s\n",dline); Lprint();
}


/* ----------------------------------------------------------------- */


int DSPOview(void)
{
 char cmlin[128];
 char *p;
 int i,j,ms,lastms=0,n,lastn=64,err,dft;
 unsigned long a,lasta=0,v;

  for (;;) {
    printf(">");
    gets(cmlin);
    p=cmlin; while(isspace(*p)) p++;
    switch(tolower(*p++)) {
      case 'q': return(0);
      case 'i': while (isspace(*p)) p++;
		err=0; dft=0;
		switch(tolower(*p++)) {
		  case 'x': ms=0x40; break;
		  case 'y': ms=0x80; break;
		  case 'p': ms=0; break;
		  case 0: dft=1; break;
		  default:  err=1;
		 }
		if (dft) {
		  v = (getmblock(lastms,lasta,1)&0xffffff);
		  lasta++;
		 }
		else {
		  if (*p==':') p++; else err=2;
		  if (!err) {
		    if (sscanf(p,"%lx",&a)==1) {
		      v = (getmblock(ms,a,1)&0xffffff);
		      lasta=a+1; lastms=ms;
		     }
		    else err=3;
		   }
		 }
		if (err) printf("ERR\n");
		 else { sprintf(Sbuf,"%06lx\n",v); Lprint(); }
		break;
      case 'd': while (isspace(*p)) p++;
		err=0; dft=0;
		switch(tolower(*p++)) {
		  case 'x': ms=0x40; break;
		  case 'y': ms=0x80; break;
		  case 'p': ms=0; break;
		  case 0: a=lasta; n=lastn; ms=lastms;
			     dft=1; break;
		  default:  err=1;
		 }
		if (!dft) {
		  if (*p==':') p++; else err=2;
		  if (!err) {
		    err=1;
		    if (sscanf(p,"%lx",&a)==1) {
		      while ((*p)&&(!isspace(*p))) p++;
		      while ((*p)&&(isspace(*p))) p++;
		      if ((*p==0)||(sscanf(p,"%x",&n)!=1)) n=64;
		      err=0;
		     }
		   }
		 }
		if (err) printf("ERR\n");
		 else {
		   getmblock(ms,a,n);
		   lasta=a+n; lastms=ms; lastn=n;
		   i=0; j=0;
		   while (n--) {
		     if (j==0) { sprintf(Sbuf,"%04x:",a); Lprint(); }
		     sprintf(Sbuf," %06lx",DSPBUF[i++]&0xffffff); Lprint();
		     j++; a++;
		     if (j==8) { sprintf(Sbuf,"\n"); Lprint(); j=0; }
		    }
		  }
		break;
#if (0)
      case 'o': while (isspace(*p)) p++;
		err=0;
		switch(tolower(*p++)) {
		  case 'x': ms=0; break;
		  case 'y': ms=1; break;
		  case 'p': ms=2; break;
		  default:  err=1;
		 }
		if (*p==':') p++; else err=1;
		if (!err) {
		  err=1;
		  if (sscanf(p,"%lx",&a)==1) {
		    while (!isspace(*p)) p++;
		    while (isspace(*p)) p++;
		    if (sscanf(p,"%lx",&v)==1) err=0;
		   }
		 }
		if (err) printf("ERR\n");
		 else DSPpoke(ms,a,v);
		break;
      case 'f': while (isspace(*p)) p++;
		err=0;
		switch(tolower(*p++)) {
		  case 'x': ms=0; break;
		  case 'y': ms=1; break;
		  case 'p': ms=2; break;
		  default:  err=1;
		 }
		if (*p==':') p++; else err=1;
		if (!err) {
		  err=1;
		  if (sscanf(p,"%lx",&a)==1) {
		    while ((*p)&&(!isspace(*p))) p++;
		    while ((*p)&&(isspace(*p))) p++;
		    if (sscanf(p,"%lx",&v)==1) {
		      err=0;
		      while ((*p)&&(!isspace(*p))) p++;
		      while ((*p)&&(isspace(*p))) p++;
		      if ((*p==0)||(sscanf(p,"%x",&n)!=1)) n=1;
		     }
		   }
		 }
		if (err) printf("ERR\n");
		 else DSPfill(ms,a,n,v);
		break;
#endif
      default:  printf("<I>nput s:addr       <O>utput s:addr val\n");
		printf("<D>ump s:addr n      <F>ill s:addr val n\n");
		break;
     }
   }
}


int testOnCE(int log)
{
 static unsigned long savePIL,savePDB;
 long v;
 long fifo[5];
 int i,err,retc=0;

  if (log) {
    flog=fopen("once56.log","at"); Olog=1;
   }
  sprintf(Sbuf,"DSP status = %02x\n",inportb(OnCEstat)&31); Lprint();
  if (err=enterOnCE(0)) {
    if (err<0) printf("OnCE already active\n");
     else printf("Timeout on DR ACK\n");
    retc=1; goto quit;
   }
  sprintf(Sbuf,"Entered OnCE debug mode, status=%02x\n",inportb(OnCEstat)&31);
  Lprint();
  if ((v=ONCErdat(O_OPDBR,0))==-1l) { retc=2; goto quit; }
  savePDB=v;
  if ((v=ONCErdat(O_OPILR,0))==-1l) { retc=3; goto quit; }
  savePIL=v;
  sprintf(Sbuf,"\nPDB=%06lx  PIL=%06lx\n",savePDB,savePIL); Lprint();
  if (ONCErdat(O_OPABFR,0)==-1l) { retc=4; goto quit; }
  if (ONCErdat(O_OPABDR,0)==-1l) { retc=5; goto quit; }
  for (i=0; i<5; i++)
    if ((fifo[i]=ONCErdat(O_FIFO,0))==-1l) { retc=6; goto quit; }
  sprintf(Sbuf,"FIFO:"); Lprint();
  for (i=0; i<5; i++) { sprintf(Sbuf," %06x",fifo[i]&0xffffffl); Lprint(); }
  sprintf(Sbuf,"\n"); Lprint();

  showallreg();

  DSPOview();

  if (ONCEwdat(O_OPDBR|O_write|O_nogo|O_noex,savePIL,1))
    { retc=7; goto quit; }
  if (ONCEwdat(O_OPDBR|O_write|O_go|O_ex,savePDB,0))
    { retc=8; goto quit; }
  sprintf(Sbuf,"\n"); Lprint();
  outportb(OnCEstat,0);		/* clear ACK */
  sprintf(Sbuf,"DSP status = %02x\n",inportb(OnCEstat)&31); Lprint();
quit:
  if (log) {
    fclose(flog); Olog=0;
   }
  isOnCE=0;
  outportb(OnCEstat,0);		/* clear ACK */
  return(retc);
}


/* ------------------------------------------------------------------- */

