
; ===================================================================

DTCStub	ident	1,0
	page	120,60,1,1,4
	opt	cc,cex,intr,mc,md,mex
	lstcol	10,,,,

; ===================================================================
	INCLUDE		'glob56.asm'
; ===================================================================
;
NULLVEC		macro
		nop
		nop
		endm

ERRVEC		macro
		jsr	>ERROR
		endm


	ORG	P:0		; bootstrap from host port

VReset	jmp	>START1		; 0000
VStkerr	ERRVEC
VTrace	ERRVEC
VSWI	ERRVEC
VIRQA	NULLVEC
VIRQB	NULLVEC
VSSIr   NULLVEC
VSSIrx  NULLVEC
VSSIt   NULLVEC
VSSItx	NULLVEC
VSCIr	NULLVEC
VSCIrx	NULLVEC
VSCIt	NULLVEC
VSCIi	NULLVEC
VSCItim	NULLVEC
VNMI	NULLVEC
VHOSTR	ERRVEC
VHOSTT	ERRVEC
VHOSTC	NULLVEC
VHC1	NULLVEC
VHC2    NULLVEC
VHC3    NULLVEC
VHC4    NULLVEC
VHC5    NULLVEC
VHC6    NULLVEC
VHC7    NULLVEC
VHC8    NULLVEC
VHC9    NULLVEC
VHC10   NULLVEC
VHC11   NULLVEC
VHC12   NULLVEC

VILLEG  ERRVEC

; ===================================================================

; wait 64k*50n = 3.28u
WAIT1	clr	a
	rep	a1
	nop
	rts

; ===================================================================

; Get a word from Host Port into A1
;
GETWORD	jclr	#M_HRDF,X:<<M_HSR,GETWORD
	movep	X:<<M_HRX,a1
	rts

;
; Put a word from X0 into Host Port
;
PUTWORD	jclr	#M_HTDE,X:<<M_HSR,PUTWORD
	movep	x0,X:<<M_HTX
	rts

; ===================================================================
;
; Error processing
;
ERROR   bset    #M_HF2,X:<<M_HCR     ; set error flag (HF23 = 11)
	bset	#M_HF3,X:<<M_HCR
	move	#$455252,x0	; 'ERR'
	movep	x0,X:<<M_HTX
	movep	x0,X:<<M_HTX
	ori     #3,MR           ; no IRQs
	nop
_stper	stop
	jmp	<_stper		; just for sure

; ===================================================================
;
; PLL after reset: ckin=5MHz
;
START1  equ     *
	reset
	ori     #3,MR           ; no IRQs
	movec	#0,SP
	nop
	move	#>$1F000b,x0	; ck*12 = 60 MHz
	movep	x0,X:<<M_PCTL
	nop
	nop
	andi    #3,MR
	move	#$FFFF,m0
	movep   #0,X:<<M_HCR
	movep   #0,X:<<M_PBD
	bset    #1,X:<<M_PBC    ; (re-)enable HI, PB14 I/O

; @60 MHz	tc=33.3n
;		1W=50.0n
;		2W=66.6n
;		3W=83.3n
;		4W=100.0n

	MEM_MODE1			; set memX!=memY
	nop

; -------------------------------------------------------
;	Configure SCI for ()B, N81
;	System clock is 60.000 MHz
;	Ext.clock is 8.000 MHz
;
; X:SCR [13=TMIE 12=TIE 11=RIE 10=ILIE 9=TE 8=RE 7=WOMS 6=RWU 5=WAKE
;         4=SBK  2-0=WDS]
;
; ========== SCI ==================================
; internal ck= 16*BR
; in ck = 30.0 MHz
; SCLK out = BR
; SCCR value = (ck/64)/BR
; BPS = (f0/64) / ((SCP?8:1)*(CD+1))
;
; -------------------------------------------------------

	movep	#$0,X:<<M_PCDDR
	movep	#$0026,X:<<M_SCR	; EXT CK - WDS=010(8N1)
	movep	#$c002,X:<<M_SCCR	; EXT CK - Scale=/3 -> 250 kHz

;	movep	#$0002,X:<<M_SCR	; INT CK - WDS=010(8N1)
;	movep	#$001d,X:<<M_SCCR	; INT CK - Scale=/30 -> 31.25 kHz

; CRA: PSR WL(2) DC(5)  PM(8)
;       0   10   0.0000.0000.0000
	movep	#$4100,X:<<M_CRA
; CRB: RIE TIE RE TE MOD GCK SYN FSL(2) SHFD SCD(4) OF(2)
;	0   0   0  0. 0   0   1   0.0    0   00.00   00
	movep	#$0200,X:<<M_CRB

; now activate SCI/SSI
	movep	#$0007,X:<<M_PCC

; --------------------------------------------

; IRQ priorities:
;	SCI  = disabled
;	SSI  = disabled
;	HOST = level 1 (10)
;	IRQB = disabled, edge trig (100)
;	IRQA = disabled, edge trig (100)
; bit setting = 00.00|10.xx|xx.10|0.100		(x=0)

	movep	#>$0824,X:<<M_IPR

	movep	#>$1114,X:<<M_BCR
	nop

; ===================================================================
;
; Read a block from host into memory
;	Word 1 = Address (00000..0FFFF P=X  10000..1FFFF Y
;			  20000..2FFFF P    40000..4FFFF execute
;			  80000..8FFFF end)
;	Word 2 = Length
;	<data>
;	Xmit back checksum
;
ELOOP	jsr	<GETWORD		; addr into A
	move	a1,r0
	btst	#19,a
	jne	_endL
	btst	#18,a
	jne	_execP
	btst	#16,a
	jne	_readY
_readX	jsr	<GETWORD		; length
	clr	b	a1,r1
	clr	a
	do	r1,_loopX
	jsr	<GETWORD
	add	a,b	a1,X:(r0)+	; X equal P
	move	a2,b2			; keep b2=0
_loopX	nop
	move	b1,x0
	jsr	<PUTWORD
	jmp	<ELOOP
;
_readY	jsr	<GETWORD		; length
	clr	b	a1,r1
	clr	a
	do	r1,_loopY
	jsr	<GETWORD
	add	a,b	a1,Y:(r0)+
	move	a2,b2
_loopY	nop
	move	b1,x0
	jsr	<PUTWORD
	jmp	<ELOOP
;
_execP	jmp	(r0)
;
_endL	wait
	jmp	<_endL
;
; ===================================================================

	end
